<?php
// $Id: html.php,v 1.1.1.1 2002/09/15 22:26:15 root Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Patrick Kellum
// Purpose of file: Display html content of the block
// ----------------------------------------------------------------------

$blocks_modules['donations'] = array (
    'func_display' => 'blocks_donations_block',
    'func_edit' => 'blocks_donations_edit',
    'func_update' => 'blocks_donations_update',
    'text_type' => 'Donations',
    'text_type_long' => 'Donations',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
    'show_preview' => true
);

// Security
pnSecAddSchema('DonationsBlock::', 'Block title::');

function blocks_donations_block($row)
{
    if (!pnSecAuthAction(0, 'DonationsBlock::', "$row[title]::", ACCESS_OVERVIEW)) {
        return;
    }
	
    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);

    // Title
    $block['title'] = $row['title'];

    // Defaults
    if (!isset($vars['showAmount'])) {
        $vars['showAmount'] = 0;
    }
    if (!isset($vars['symbol'])) {
        $vars['symbol'] = "$ ";
    }
    
	$block['content'] .= "<center>";	//begin centering
	
	// Add a subtitle if defined
	if(isset($vars['subtitle'])){
		$block['content'] .= "<i>".$vars['subtitle']."</i><br>";
    }
	
	// Add the button code if defined
    if (isset($vars['buttonCode'])) {
		$block['content'] .= $vars['buttonCode']."<br><br>";
    }


	// List the Donators
    if (!empty($vars['content'])) {
		$block['content'] .= "<b><i>Top Donators</i><br>";
		$block['content'] .= "</center>";	//stop centering
		
		$content = 0;
        $contentlines = explode("LINESPLIT", $vars['content']);
        foreach ($contentlines as $contentline) {
            list($amount, $name) = explode('|', $contentline);
			
			//Add a linebreak if this is not the first name in the list
			if($content){
				$block['content'] .= "<br>";
			}
			
			$block['content'] .= pnVarPrepForDisplay($name);
			if($vars['showAmount']==1){
				//Show the donation amount next to the name
				$block['content'] .= "&nbsp;&nbsp;";	//add some spaces
				
				//Add some styling to the amount
				$block['content'] .= "<i>";

				//Actually add the symbol and amount
				$block['content'] .= "(".pnVarPrepForDisplay($vars['symbol'])."".pnVarPrepForDisplay($amount).")";
				
				//Close the amount styling
				$block['content'] .= "</i>";
			}
			$content = 1;
        }
		
		$block['content'] .= "</b></div>";
    }

	$row['title'] = $block['title'];
	$row['content'] = $block['content'];

	return themesideblock($row);
}

function blocks_donations_edit($row)
{
    global $pntheme;

    // Break out options from our content field
    $vars = pnBlockVarsFromContent($row['content']);
    $row['content'] = "";

    // Defaults
    if (!isset($vars['showAmount'])) {
        $vars['showAmount'] = 0;
    }
    if (!isset($vars['symbol'])) {
        $vars['symbol'] = "$ ";
    }
    if (!isset($vars['buttonCode'])) {
        $vars['buttonCode'] = "[insert donation button code here]";
    }

    // Show the donation amount?
    $output = '<tr><td>Show the donation amount next to the name?</td><td><input type="checkbox" name="showAmount" value="1"';
    if ($vars['showAmount'] == 1) {
        $output .= ' checked';
    }
    $output .= ' ></td></tr>';
    
	// Monetary symbol ($)
	$output .= '<tr><td>What should preceed the amount?</td><td><input type="text" name="symbol" size="3" maxlength="3" value="'.$vars['symbol'].'"></td></tr>';

	// Subtitle
	$output .= '<tr><td>Subtitle text: (italics at top of block above button)</td><td><input type="text" name="subtitle" size="60" maxlength="255" value="'.$vars['subtitle'].'"></td></tr>';

	// Button code
	$output .= '<tr><td>Donation Button Code:</td><td>&nbsp;</td></tr>'
				. '<tr><td colspan="2" align="right"><textarea name="buttonCode" cols="55" rows="10">'.$vars['buttonCode'].'</textarea></td></tr>';

    // Content
    $c=1;
    $output .= "</table><table>";
    $output .= "<tr><td valign=\"top\" class=\"pn-title\">Donators:"
    ."</td><td><table border=\"1\"><tr><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><b>"
    ."Name</b></td><td align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><b>"
    ."Amount</b></td><td width=\"100px\" align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><b>"
    ."Remove</b></td><td width=\"250px\" align=\"center\" class=\"pn-normal\" style=\"color:$pntheme[table_header_text]; background-color:$pntheme[table_header]; text-align:center\"><b>Insert New Row</b></td></tr>";
    if (!empty($vars['content'])) {
        $contentlines = explode("LINESPLIT", $vars['content']);
        foreach ($contentlines as $contentline) {
            $link = explode('|', $contentline);
            $output .= "<tr><td valign=\"top\"><input type=\"text\" name=\"linkname[$c]\" size=\"30\" maxlength=\"255\" value=\"" . pnVarPrepForDisplay($link[1]) . "\" class=\"pn-normal\"></td><td valign=\"top\"><input type=\"text\" name=\"linkurl[$c]\" size=\"8\" maxlength=\"6\" value=\"" . pnVarPrepForDisplay($link[0]) . "\" class=\"pn-normal\"></td><td valign=\"top\" align=\"center\"><input type=\"checkbox\" name=\"linkdelete[$c]\" value=\"1\" class=\"pn-normal\"></td><td valign=\"top\" align=\"center\"><input type=\"checkbox\" name=\"linkinsert[$c]\" value=\"1\" class=\"pn-normal\" /></td></tr>\n";
            $c++;
        }
    }

    $output .= "<tr><td><input type=\"text\" name=\"new_linkname\" size=\"30\" maxlength=\"255\" class=\"pn-normal\" /></td><td><input type=\"text\" name=\"new_linkurl\" size=\"8\" maxlength=\"6\" class=\"pn-normal\" /></td><td class=\"pn-normal\" align=\"center\">&nbsp;</td><td class=\"pn-normal\" align=\"center\"><input type=\"checkbox\" name=\"new_linkinsert\" value=\"1\" class=\"pn-normal\" /></td></tr>\n";
    $output .= '</table></td></tr>';

    return $output;

}

function blocks_donations_update($row)
{
    $vars['showAmount'] = pnVarCleanFromInput('showAmount');
	list($vars['symbol'], 
		 $vars['buttonCode'],
		 $vars['subtitle'])   = pnVarCleanFromInput('symbol', 
													'buttonCode',
													'subtitle');

    // Defaults
    if (!isset($vars['showAmount'])) {
        $vars['showAmount'] = 0;
    }
    if (!isset($vars['symbol'])) {
        $vars['symbol'] = "$ ";
    }
    if (!isset($vars['buttonCode'])) {
        $vars['buttonCode'] = "";
    }

    // User links
    $content = array();
    $c = 1;
    if (isset($row['linkname'])) {
        list($linkurl, $linkname) = pnVarCleanFromInput('linkurl', 'linkname');
        foreach ($row['linkname'] as $v) {
            if (!isset($row['linkdelete'][$c])) {
                $content[] = "$linkurl[$c]|$linkname[$c]";
            }
            if (isset($row['linkinsert'][$c])) {
                $content[] = "|";
            }
            $c++;
        }
    }
    if ($row['new_linkname']) {
       $content[] = pnVarCleanFromInput('new_linkurl').'|'.pnVarCleanFromInput('new_linkname');
    }
    $vars['content'] = implode("LINESPLIT", $content);

    $row['content']=pnBlockVarsToContent($vars);

    return($row);
}
?>