<?php
// File: $Id: user.php,v 1.17.2.1 2002/05/15 16:13:24 byronmhome Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Scott Rubin - phpnuke id: scottr -
// http://www.ierealtor.com - 1/2003
// email: scottr2@earthlink.net
// ----------------------------------------------------------------------
// PostNuke Adaptation : Franois Deschnes ! A.K.A. Chestnut !
// http://dev.pnconcept.com
// Purpose of file: Donations block to accept money thru PayPal.
// ----------------------------------------------------------------------
//
// This assumes you have already setup an account with PayPal.

$blocks_modules['pncpaypalcontribute'] = array( 'text_type'           => 'pncpaypalcontribute',
                                                'text_type_long'      => 'Paypal Contribute Block',
                                                'func_display'        => 'blocks_pncpaypalcontribute_block',
                                                'func_edit'           => 'blocks_pncpaypalcontribute_modify',
                                                'func_update'         => 'blocks_pncpaypalcontribute_update',
                                                'allow_multiple'      => true,
                                                'form_content'        => false,
                                                'form_refresh'        => false,
                                                'show_preview'        => true);

pnSecAddSchema('pncPayPalContributeblock::', 'Block title::');

function blocks_pncpaypalcontribute_block($blockinfo)
{

    if (!pnSecAuthAction(0, 'pncPayPalContributeblock::', "$blockinfo[title]::", ACCESS_READ)) {
        return;
    }
    
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    if (empty($vars['paypal_email'])) {
        $vars['paypal_email'] = '';
    }

    if (empty($vars['currency_code'])) {
        $vars['currency_code'] = 'USD';
    }
    
    if ($vars['topmsg']."" == "") {
        $vars['topmsg'] = _PAYPALTOPMESSAGE;
    }

    if ($vars['bottommsg']."" == "") {
        $vars['bottommsg'] = _PAYPALBOTTOMMESSAGE;
    }
    
    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    $output->Text("<center>\n");
    
    if ($vars['paypal_email']."" == "") {
        $output->Text(_NOPAYPALEMAIL);
    } else {
    
        $output->Text("<b>".pnVarPrepHTMLDisplay($vars['topmsg'])."</b>\n");

        $output->Text("<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">\n");
        $output->Text("<input type=\"hidden\" name=\"cmd\" value=\"_xclick\">\n");
        $output->Text("<input type=\"hidden\" name=\"business\" value=\"".$vars['paypal_email']."\">\n");
        $output->Text("<input type=\"hidden\" name=\"item_name\" value=\"Contribution\">\n");
        $output->Text("<input type=\"hidden\" name=\"no_shipping\" value=\"1\">\n");
        $output->Text("<input type=\"hidden\" name=\"currency_code\" value=\"".pnVarPrepForDisplay($vars['currency_code'])."\">\n");
        $output->Text("<input type=\"image\" src=\"https://www.paypal.com/images/x-click-but04.gif\" border=\"0\" name=\"submit\" alt=\""._PAYPALALTIMAGE."\">");
        $output->Text("</form>");

        $output->Text("".pnVarPrepHTMLDisplay($vars['bottommsg'])."\n");
    }
    
    $output->Text("</center>");

    $output->SetInputMode(_PNH_PARSEINPUT);
    $blockinfo['content'] = $output->GetOutput();
    themesideblock($blockinfo);

}

function blocks_pncpaypalcontribute_modify($blockinfo)
{
    $output = new pnHTML();

    $vars = pnBlockVarsFromContent($blockinfo['content']);

    if (empty($vars['paypal_email'])) {
        $vars['paypal_email'] = '';
    }

    if (empty($vars['currency_code'])) {
        $vars['currency_code'] = 'USD';
    }

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_PAYPALEMAIL);
    $row[] = $output->FormText('paypal_email',
                               $vars['paypal_email'],
                               30,
                               30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_CURRENCYCODE);
    
    $currency[] = array('id'    => "USD",
                        'name'  => _CURRENCYUSD);
    $currency[] = array('id'    => "EUR",
                        'name'  => _CURRENCYEUR);
    $currency[] = array('id'    => "GBP",
                        'name'  => _CURRENCYGBP);
    $currency[] = array('id'    => "CAD",
                        'name'  => _CURRENCYCAD);
    $currency[] = array('id'    => "JPY",
                        'name'  => _CURRENCYJPY);

    $row[] = $output->FormSelectMultiple('currency_code',
                                         $currency,
                                         0,
                                         1,
                                         $vars['currency_code']);
    
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    return $output->GetOutput();
}

function blocks_pncpaypalcontribute_update($blockinfo)
{
    list($vars['paypal_email'], $vars['currency_code']) = pnVarCleanFromInput('paypal_email', 'currency_code');

    $blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}
?>