<?php
// $Id: pnadmin.php,v 1.2 2003/07/02 23:47:33 markwest Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file:  PayPalCart administration display functions
// ----------------------------------------------------------------------
	
	
$currency_markers = array ('USD' => '$',
                           'EUR' => '&#8364;',
														'GBP' => '&pound;',
														'CAD' => '$',
														'JPY' => '&yen;');	 
	 
$GLOBALS['currency_symbol'] = $currency_markers[pnModGetVar('PayPalCart', 'currency')];	 
														
																	
// Main administration menu load
function paypalcart_admin_main() {

    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart::', '::', ACCESS_EDIT)) {
        $output->Text(_PPC_NOAUTH);
        return $output->GetOutput();
    }
		
    include('header.php');		

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');			
		
    // Return the output that has been generated by this function
    return $output->GetOutput();
		
	
}


// Main Administration Menu HTML
function paypalcart_adminmenu() {

    if(!pnModAPILoad('PayPalCart', 'admin')){
		    return paypalcart_admin_error(_ERROR_LOAD);
				}
				

    $authid = pnSecGenAuthKey();
    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
				
    OpenTable2();
    
		?>
		
		<SPAN CLASS="pn-title"><?php echo _PPC_TITLE; ?> <?php echo _PPC_ADMIN_TITLE; ?></SPAN>
		
		<?php
		
		CloseTable2();	
		
    paypalcart_admin_submenu($authid);		
		
		$optionlist = paypalcart_admin_optionselectlist();
		
		if ($optionlist) {
		
		?>
		
		
		<FORM ACTION="<?php echo pnModURL('PayPalCart','admin','editoptionmenu', array('authid' => $authid)); ?>" METHOD="POST"><SPAN CLASS="pn-normal"><B><?php echo _PPC_EDITOPTION ?>:</B></SPAN> <SELECT NAME="oid" CLASS="pn-normal">
		
		<?php echo $optionlist; ?>
		
		</SELECT>&nbsp;&nbsp;<INPUT TYPE="SUBMIT" VALUE="<?php echo _PPC_EDIT ;?>" CLASS="pn-normal" STYLE="text-align: center;"></FORM>
		
		<?php
		}
		
		if (pnSecAuthAction(0, 'PayPalCart:Upload:Edit', "::", ACCESS_EDIT)) {
		
		?>
		
	   <FORM METHOD="POST" enctype="multipart/form-data" action="<?php echo pnModURL('PayPalCart', 'admin', 'imageupload', array('authid' => $authid)); ?>">
	   <SPAN CLASS="pn-normal"><B><?php echo _PPC_IMAGEUPLOAD ?>:</B></SPAN>  <input type="file" name="img" size="30" accept="image/jpeg, image/jpg, image/gif, image/png" CLASS="pn-normal">
	   <input type="submit" value="<?php echo _PPC_UPLOAD ?>" CLASS="pn-normal"></FORM>				

		<?php
		
		}
		
		if (pnSecAuthAction(0, 'PayPalCart:Upload:Edit', "::", ACCESS_DELETE)) {
				
		    ?>
				
		<SPAN CLASS="pn-normal">[&nbsp;<A HREF="<?php echo pnModURL('PayPalCart', 'admin', 'imagepurge', array('authid' => $authid)); ?>" CLASS="pn-normal"><?php echo _PPC_IMAGEPURGE ?></A>&nbsp;]</SPAN><BR><BR>
		
		<?
		
		}
		
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
    $sql = "SELECT $ppc_categories_column[cid], $ppc_categories_column[name], $ppc_categories_column[active] FROM $ppc_categories_table ORDER BY $ppc_categories_column[order]";
 		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
		// $catcount = $result->PO_RecordCount();	
		// Permission update - do count to see what cats user can edit, if any
		for (; !$result->EOF; $result->MoveNext()) {
		
		    list($cid, $cat_name, $active) = $result->fields;
				
				if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
            $catcount++;
        }		
		
		}
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo _PPC_EDITCATEGORIES; ?></SPAN>
    
		<?php
		
		CloseTable2();
		
    ?>

		</DIV>		
		
		<?php
		
		if ($catcount) {		
		
		    echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="5" WIDTH="100%">';	
		    echo '<tr class="pn-normal">';
				echo '<th width="30" colspan="2">'._PPC_ORDER.'</th>';
					echo '<th width="30">'._PPC_ACTIVE.'</th><th width="30">'._PPC_ID.'</th><th colspan="2">'._PPC_CATEGORYNAME.'</th><th colspan="2">'._PPC_NUMPRODUCTS.'</th></tr>';				
		
        $result = $dbconn->Execute($sql);
				
				for (; !$result->EOF; $result->MoveNext()) {
					
            list($cid, $cat_name, $active) = $result->fields;
				
				    if (!pnSecAuthAction(0, 'PayPalCart:Category:', "::$cid", ACCESS_EDIT)) {
                continue;
            }								
						
            // Get product count of this category
						$sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = '$cid'";
 		        $result2 = $dbconn->Execute($sql);
		
            if ($dbconn->ErrorNo() != 0) {
                return false;
            }
						
						$prodcount = 0;
						
						// Permission update - do count to see what # items user can edit, if any
		        for (; !$result2->EOF; $result2->MoveNext()) {
		
						    list($pid) = $result2->fields;	
				
				        if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT)) {
                    $prodcount++;
								}		
		
		        }

						$count++;
						
						$activecheck = '';
						
						// Set flag to output hyperlinks if permissions to edit active
						if (pnSecAuthAction(0, 'PayPalCart:Category:Active', "::$cid", ACCESS_EDIT))
						    $activepermflag = 1;
			
            if ($active == '1') {
						    if ($activepermflag)
			              $activecheck .= '<A HREF="'.pnModURL('PayPalCart','admin','changecategorystatus', array('cid' => $cid, 'status' => 'inactive', 'authid' => $authid)).'">';

                $activecheck .= '<IMG SRC="modules/PayPalCart/pnimages/active.gif" ALT="'._PPC_DEACTIVATE.'" BORDER="0">';
							
			      } else {
						    if ($activepermflag)
			              $activecheck .= '<A HREF="'.pnModURL('PayPalCart','admin','changecategorystatus', array('cid' => $cid, 'status' => 'active', 'authid' => $authid)).'">';
		            
								$activecheck .= '<IMG SRC="modules/PayPalCart/pnimages/inactive.gif" ALT="'._PPC_ACTIVATE.'" BORDER="0">';								
            }
						
						if ($activepermflag)
			          $activecheck .= '</A>';
						
            $activepermflag = 0;
				
			      echo '<tr class="pn-normal">';
						echo '<td align="center">';						

						
						// Check permissions for ordering
						if (pnSecAuthAction(0, 'PayPalCart:Category:Order', "::$cid", ACCESS_EDIT)) {
						
						    // Output up arrow
						    if ($count !=1) {
						
						        ?><A HREF="<?php echo pnModURL('PayPalCart','admin','deccategory',array('cid' => $cid ,'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up.gif" ALT="<?php echo _PPC_MOVEUP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						    }
						
						    // Output down arrow
						    if ($count < $catcount) {
						
						        ?><A HREF="<?php echo pnModURL('PayPalCart','admin','inccategory', array('cid' => $cid ,'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down.gif" ALT="<?php echo _PPC_MOVEDOWN; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						    }						
						 
						}   
				
				    echo '&nbsp;</td>';
						
						echo '<td align="center">';
						
						if (pnSecAuthAction(0, 'PayPalCart:Category:Order', "::$cid", ACCESS_EDIT)) {						
						
		
						    // Output up to top arrow
						    if ($count !=1) {
						
						        ?><A HREF="<?php echo pnModURL('PayPalCart','admin','deccategory',array('cid' => $cid, 'totop' => 1, 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up2.gif" ALT="<?php echo _PPC_MOVETOTOP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						    }
					
						
						    // Output down to bottom arrow
						    if ($count < $catcount) {
						
						        ?><A HREF="<?php echo pnModURL('PayPalCart','admin','inccategory', array('cid' => $cid, 'tobot' => 1, 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down2.gif" ALT="<?php echo _PPC_MOVETOBOTTOM; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						    }						


						   
				    }  // End order permission check
						
				    echo '&nbsp;</td>';							
						
						echo '<td align="center">'.$activecheck.'</td><td>'.$cid.'</td><td>'.$cat_name.'</td><td align="center">';
						
						if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT))
                echo '[&nbsp;<a href="'. pnModURL('PayPalCart','admin','editcategorymenu', array('cid' => $cid, 'authid' => $authid)) .'" CLASS="pn-normal">'._PPC_EDIT.'</a>&nbsp;]';
						else
						    echo '&nbsp;';
						
						echo '</td><td align="center">'.$prodcount.'</td><td align="center">';
						
						if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT) && pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::", ACCESS_ADD)) {
                echo '[&nbsp;<a href="'. pnModURL('PayPalCart','admin','edititemmenu', array('cid' => $cid, 'authid' => $authid)).'" CLASS="pn-normal">'._PPC_ADDITEM.'</a>&nbsp;]';
            }	else {
						    echo '&nbsp;';
						}	
						
				    echo '</td></tr>';
				
        }	
		
		    echo '</TABLE>';						

        $result->Close();	
		
		} else {
		
		?>
		
		<BR>
		<DIV ALIGN="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOCATEGORIESDEFINED; ?></SPAN></DIV>
		
		<?php
		
		}  // end if->catcount check...		
		
		
		CloseTable();

    return;
}



// Modify config page load
function paypalcart_admin_modifyconfig() {
		
    $args['authid'] = pnVarCleanFromInput('authid');	

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Config:Edit', '::', ACCESS_ADMIN)) {
        paypalcart_admin_error(_PPC_NOAUTH);
        exit;
    }
		
		// Create output object
		$output = new pnHTML();		

    include('header.php');			
		
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_admin_modifyconfigform($args));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');	
		
    // Return the output that has been generated by this function
    return $output->GetOutput();
		
	
}


// Form output for config modify page
function paypalcart_admin_modifyconfigform($args) {


    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo _PPC_MODIFYCONFIG; ?></SPAN></CENTER>
		
		<?php
		
    CloseTable2();
		
    paypalcart_admin_submenu($args['authid']);				
		
		?>
		
		</DIV>
		
    <FORM METHOD="POST" ACTION="<?php echo pnModUrl('PayPalCart', 'admin', 'updateconfig');  ?>">
    <INPUT TYPE="HIDDEN" NAME="authid" VALUE="<?php echo $args['authid']; ?>">
		
		<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="8">
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD WIDTH="33%"><SPAN CLASS="pn-normal"><B><?php echo _PPC_ACCOUNTEMAIL; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="paypal_email" VALUE="<?php echo pnModGetVar('PayPalCart', 'paypal_email') ?>" SIZE="40" CLASS="pn-normal">
		    <BR><SPAN CLASS="pn-sub"><?php echo _PPC_ACCOUNTEMAILDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_STOREEMAIL; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="store_email" VALUE="<?php echo pnModGetVar('PayPalCart', 'store_email') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_STOREEMAILDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_CURRENCY; ?>:</B></SPAN>
		</TD>
		<TD>
		
		<SELECT NAME="currency" CLASS="pn-normal">
		
		<?php echo paypal_admin_arrayselectlist($GLOBALS['ppc_currency'], pnModGetVar('PayPalCart', 'currency')); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CURRENCYDESC; ?></SPAN>
		</TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_HANDLING_CART; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $GLOBALS['currency_symbol']; ?></SPAN> <INPUT TYPE="TEXT" NAME="handling_cart" VALUE="<?php echo pnModGetVar('PayPalCart', 'handling_cart') ?>" SIZE="8" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_HANDLING_CARTDESC; ?></SPAN></TD>
		</TR>
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_NOTE; if (pnModGetVar('PayPalCart', 'note')) $notecheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="note" VALUE="1" <?php echo $notecheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_NOTEDESC; ?></SPAN></TD>
		</TR>		

		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_NOTEMSG; ?>:</B></SPAN></TD>
		<TD>
		<TEXTAREA NAME="notemsg" ROWS="2" STYLE="width: 100%;" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'notemsg') ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_NOTEMSGDESC; ?></SPAN>
		</TD>
		</TR>
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_SHIPPINGADDR; if (pnModGetVar('PayPalCart', 'shippingaddr')) $shippingcheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="shippingaddr" VALUE="1" <?php echo $shippingcheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_SHIPPINGADDRDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_PAGESTYLE; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="page_style" VALUE="<?php echo pnModGetVar('PayPalCart', 'page_style') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_PAGESTYLEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_IMGURL; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="image_url" VALUE="<?php echo pnModGetVar('PayPalCart', 'image_url') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_IMGURLDESC; ?></SPAN></TD>
		</TR>
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_BGCOLOR; if (pnModGetVar('PayPalCart', 'bgcolor')) $bgcolorcheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="bgcolor" VALUE="1" <?php echo $bgcolorcheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_BGCOLORDESC; ?></SPAN>
		</TD>
		</TR>		
						
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_STORENAME; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="storename" VALUE="<?php echo pnModGetVar('PayPalCart', 'storename') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_STORENAMEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_STOREINTRO; ?>:</B></SPAN></TD>
		<TD>
		<TEXTAREA NAME="storeintro" ROWS="3" STYLE="width: 100%;" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'storeintro') ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_STOREINTRODESC; ?></SPAN>
		
		</TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_STOREINFO; ?>:</B></SPAN></TD>
		<TD>
		<TEXTAREA NAME="storeinfo" ROWS="7" STYLE="width: 100%;" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'storeinfo') ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_STOREINFODESC; ?></SPAN>
		
		</TD>
		</TR>		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_THANKSTITLE; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="thankstitle" VALUE="<?php echo pnModGetVar('PayPalCart', 'thankstitle') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_THANKSTITLEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_THANKSTEXT; ?>:</B></SPAN></TD>
		<TD>
		<TEXTAREA NAME="thankstext" ROWS="3" STYLE="width: 100%;" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'thankstext') ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_THANKSTEXTDESC; ?></SPAN>
		
		</TD>
		</TR>
		

				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_BUTTONDETAILONLY; ?>:</B></SPAN>
		</TD>
		<TD>
		
		<SELECT NAME="buttondetailonly" CLASS="pn-normal">
		
		<?php echo paypal_admin_arrayselectlist($GLOBALS['ppc_cartbuttons'], pnModGetVar('PayPalCart', 'buttondetailonly')); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_BUTTONDETAILONLYDESC; ?></SPAN>
		</TD>
		</TR>				
		
		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_CATEGORYCOLUMNS; ?>:</B></SPAN></TD>
		<TD><SELECT NAME="categorycolumns" CLASS="pn-normal"><?php echo paypal_admin_numberelectlist(1,8,pnModGetVar('PayPalCart', 'categorycolumns')); ?>
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CATEGORYCOLUMNSDESC; ?></SPAN></TD>
		</TR>		

				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMSPERPAGE; ?>:</B></SPAN></TD>
		<TD><SELECT NAME="itemsperpage" CLASS="pn-normal"><?php echo paypal_admin_numberelectlist(1,50,pnModGetVar('PayPalCart', 'itemsperpage')); ?>
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMSPERPAGEDESC; ?></SPAN></TD>
		</TR>
		
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_NOJSCRIPT; if (pnModGetVar('PayPalCart', 'nojscript')) $nojscriptcheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="nojscript" VALUE="1" <?php echo $nojscriptcheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_NOJSCRIPTDESC; ?></SPAN></TD>
		</TR>				
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_CARTWINDOWSIZE; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo _PPC_CARTWINDOWWIDTH; ?>:</SPAN> 
		<INPUT TYPE="TEXT" NAME="cartwindowwidth" VALUE="<?php echo pnModGetVar('PayPalCart', 'cartwindowwidth') ?>" SIZE="8" CLASS="pn-normal">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<SPAN CLASS="pn-normal"><?php echo _PPC_CARTWINDOWHEIGHT; ?>:</SPAN> 
		<INPUT TYPE="TEXT" NAME="cartwindowheight" VALUE="<?php echo pnModGetVar('PayPalCart', 'cartwindowheight') ?>" SIZE="8" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CARTWINDOWDESC; ?></SPAN></TD>
		</TR>

		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_IMAGEPATH; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="imagepath" VALUE="<?php echo pnModGetVar('PayPalCart', 'imagepath') ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_IMAGEPATHDESC; ?></SPAN></TD>
		</TR>		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_BUTTONIMAGE; ?>:</B></SPAN></TD>
		<TD>
		<SELECT NAME="buttonimage" CLASS="pn-normal" onChange="document.images.bimage.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		
		<?php 
		
		$buttonimage = pnModGetVar('PayPalCart', 'buttonimage');
		
		echo paypal_admin_imageselectlist($buttonimage);
		
		if (!$buttonimage)
		    $buttonimage = 'transparent.png';

    ?>
		
		</SELECT>&nbsp;&nbsp;<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $buttonimage; ?>" name="bimage" alt="" align="top">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_BUTTONIMAGEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_VIEWCARTIMAGE; ?>:</B></SPAN></TD>
		<TD>
		<SELECT NAME="viewcartimage" CLASS="pn-normal" onChange="document.images.vcimage.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		
		<?php
		
		$cartimage = pnModGetVar('PayPalCart', 'viewcartimage');
		
		echo paypal_admin_imageselectlist($cartimage);

    if (!$cartimage)
			    $cartimage = 'transparent.png';

    ?>
		
		</SELECT>&nbsp;&nbsp;<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $cartimage; ?>" name="vcimage" alt="" align="top">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_VIEWCARTIMAGEDESC; ?></SPAN>
		</TD>
		</TR>	
		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_STORELOGO; ?>:</B></SPAN></TD>
		<TD><SELECT NAME="storelogo" CLASS="pn-normal" onChange="document.images.image.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		
		<?php 
		
		$storelogo = pnModGetVar('PayPalCart', 'storelogo');		

		echo paypal_admin_imageselectlist($storelogo); 
		
		if (!$storelogo)
		    $storelogo = 'transparent.png';		
		
		?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_STORELOGODESC; ?></SPAN>
		
		</TD>
		</TR>		
		
		<TR VALIGN="TOP" ALIGN="CENTER"><TD COLSPAN="2"><BR>
		<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $storelogo; ?>" name="image" alt="" align="top">
		</TD></TR>			
		
		
		</TABLE>
    <BR>
		
		<DIV ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="SUBMIT" CLASS="pn-normal" STYLE="text-align: center;" VALUE="<?php echo _PPC_UPDATECONFIG; ?>">
		
	&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart', 'admin', 'main'); ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">
		
		</DIV>
		</FORM>
    
		<?php
		
		CloseTable();
 
    return ;
}


// Update configuration variables
function paypalcart_admin_updateconfig() {

    // Get parameters from configuration variable form
    $paypal_email = pnVarCleanFromInput('paypal_email');
    $store_email = pnVarCleanFromInput('store_email');
    $currency = pnVarCleanFromInput('currency');
    $handling_cart = pnVarCleanFromInput('handling_cart');
    $note = pnVarCleanFromInput('note');
    $notemsg = pnVarCleanFromInput('notemsg');
    $shippingaddr = pnVarCleanFromInput('shippingaddr');
    $page_style = pnVarCleanFromInput('page_style');
    $image_url = pnVarCleanFromInput('image_url');
    $bgcolor = pnVarCleanFromInput('bgcolor');
    $storename = pnVarCleanFromInput('storename');
    $storeintro = pnVarCleanFromInput('storeintro');
    $storeinfo = pnVarCleanFromInput('storeinfo');		
    $storelogo = pnVarCleanFromInput('storelogo');		
    $thankstitle = pnVarCleanFromInput('thankstitle');
    $thankstext = pnVarCleanFromInput('thankstext');
    $itemsperpage = pnVarCleanFromInput('itemsperpage');
    $buttondetailonly = pnVarCleanFromInput('buttondetailonly');			
    $categorycolumns = pnVarCleanFromInput('categorycolumns');		
    $imagepath = pnVarCleanFromInput('imagepath');				
    $buttonimage = pnVarCleanFromInput('buttonimage');			
    $viewcartimage = pnVarCleanFromInput('viewcartimage');	
    $nojscript = pnVarCleanFromInput('nojscript');			
    $cartwindowwidth = pnVarCleanFromInput('cartwindowwidth');					
    $cartwindowheight = pnVarCleanFromInput('cartwindowheight');	
		

    if ($storelogo == 'transparent.png')
		    $storelogo = '';			
																								

    // Confirm authorisation code.
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Set any required variables if left blank
    if (!isset($itemsperpage) || !is_numeric($itemsperpage)) {
        $itemsperpage = 5;
    }
		
    if (!isset($categorycolumns) || !is_numeric($categorycolumns)) {
        $categorycolumns = 2;
    }		
		
    // Update module configuration variabels
		pnModSetVar('PayPalCart', 'paypal_email', $paypal_email);
    pnModSetVar('PayPalCart', 'store_email', $store_email);
    pnModSetVar('PayPalCart', 'currency', $currency);
    pnModSetVar('PayPalCart', 'handling_cart', $handling_cart);
    pnModSetVar('PayPalCart', 'note', $note);
    pnModSetVar('PayPalCart', 'notemsg', $notemsg);
    pnModSetVar('PayPalCart', 'shippingaddr', $shippingaddr);
    pnModSetVar('PayPalCart', 'page_style', $page_style);
    pnModSetVar('PayPalCart', 'image_url', $image_url);
    pnModSetVar('PayPalCart', 'bgcolor', $bgcolor);
    pnModSetVar('PayPalCart', 'storename', $storename);		
    pnModSetVar('PayPalCart', 'storeintro', $storeintro);		
    pnModSetVar('PayPalCart', 'storeinfo', $storeinfo);			
    pnModSetVar('PayPalCart', 'storelogo', $storelogo);			
    pnModSetVar('PayPalCart', 'thankstitle', $thankstitle);		
    pnModSetVar('PayPalCart', 'thankstext', $thankstext);		
    pnModSetVar('PayPalCart', 'itemsperpage', $itemsperpage);	
    pnModSetVar('PayPalCart', 'buttondetailonly', $buttondetailonly);				
    pnModSetVar('PayPalCart', 'categorycolumns', $categorycolumns);			
    pnModSetVar('PayPalCart', 'imagepath', $imagepath);		
    pnModSetVar('PayPalCart', 'buttonimage', $buttonimage);		
    pnModSetVar('PayPalCart', 'viewcartimage', $viewcartimage);	
    pnModSetVar('PayPalCart', 'nojscript', $nojscript);				
    pnModSetVar('PayPalCart', 'cartwindowwidth', $cartwindowwidth);			
    pnModSetVar('PayPalCart', 'cartwindowheight', $cartwindowheight);										
		
    pnSessionSetVar('statusmsg', _PPC_CONFIGUPDATED);						

    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));

    return true;
}



// Item edit/add page load
function paypalcart_admin_edititemmenu() {
		
    $args['pid'] = pnVarCleanFromInput('pid');	
    $args['cid'] = pnVarCleanFromInput('cid');					

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$args[pid]", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$args[cid]", ACCESS_EDIT)) {
        paypalcart_admin_error(_PPC_NOAUTH);
        exit;
    }
		
		// Create output object
		$output = new pnHTML();		

    include('header.php');			
		
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_admin_edititemform($args));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');	
		
    return $output->GetOutput();
		
}


// Form output for item add/edit menu
function paypalcart_admin_edititemform($args) {

    extract($args);
		
    $authid = pnSecGenAuthKey();		
	 
    if (!pnModAPILoad('PayPalCart', 'admin')){
		    return paypal_admin_error(_ERROR_LOAD);
				}	


    if (!empty($pid)) {
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
        extract($items);	
			  $pagetitle = _PPC_EDITITEM.': '.$prod_name;
			  $action = pnModUrl('PayPalCart', 'admin', 'updateitem'); 
	  } else {
	      $pagetitle = _PPC_ADDITEM;
			  $action = pnModUrl('PayPalCart', 'admin', 'createitem');
				$option1 = '0'; 	
				$option2 = '0'; 
				$active = '1'; 
				$amount = '0.00';	
				$shipping = '0.00';	
				$shipping2 = '0.00';	
				$handling = '0.00';														
				$prod_name = _PPC_ITEMNAME;																				  
    }

    // Begin HTML for edit/add menu
    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo $pagetitle; ?></SPAN>
    
		<?php
		
		CloseTable2();
		
    paypalcart_admin_submenu($authid);				
		
    ?>

		</DIV>
		
    <FORM METHOD="POST" ACTION="<?php echo $action; ?>">
    <INPUT TYPE="HIDDEN" NAME="authid" VALUE="<?php echo $authid; ?>">
    <INPUT TYPE="HIDDEN" NAME="pid" VALUE="<?php echo $pid; ?>">
		<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="8">
	
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD WIDTH="33%"><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMNAME; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="prod_name" VALUE="<?php echo $prod_name; ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMNAMEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMSKU; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="sku" VALUE="<?php echo $sku; ?>" SIZE="15" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMSKUDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMDESC; ?>:</B></SPAN></TD>
		<TD><TEXTAREA NAME="desc" ROWS="3" STYLE="width: 100%;" CLASS="pn-normal"><?php echo $desc; ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMDESCDESC; ?></SPAN></TD>
		</TR>
		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMCATEGORY; ?>:</B></SPAN>
		</TD>
		<TD><SELECT NAME="cid" CLASS="pn-normal">
		
		<?php echo paypalcart_admin_categoryselectlist($cid); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMCATEGORYDESC; ?></SPAN>
		<INPUT TYPE="HIDDEN" NAME="old_cid" VALUE="<?php echo $cid; ?>">
		</TD>
		</TR>		
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMAMOUNT; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $GLOBALS['currency_symbol']; ?></SPAN> <INPUT TYPE="TEXT" NAME="amount" VALUE="<?php echo $amount; ?>" SIZE="8" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMAMOUNTDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMOPTION1; ?>:</B></SPAN></TD>
		<TD>
		
		<SELECT NAME="option1" CLASS="pn-normal">
		<OPTION VALUE="0"><?php echo _PPC_NOOPTION ?></OPTION>
		
		<?php echo paypalcart_admin_optionselectlist($option1); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMOPTION1DESC; ?></SPAN>
		</TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMOPTION2; ?>:</B></SPAN></TD>
		<TD>
    <SELECT NAME="option2" CLASS="pn-normal">
		<OPTION VALUE="0"><?php echo _PPC_NOOPTION ?></OPTION>
				
		<?php echo paypalcart_admin_optionselectlist($option2); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMOPTION2DESC; ?></SPAN>		
		</TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMSHIPPING; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $GLOBALS['currency_symbol']; ?></SPAN> <INPUT TYPE="TEXT" NAME="shipping" VALUE="<?php echo $shipping; ?>" SIZE="6" CLASS="pn-normal">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<SPAN CLASS="pn-normal"><?php echo _PPC_ITEMSHIPPING2; ?>:</SPAN> <SPAN CLASS="pn-normal"><?php echo $GLOBALS['currency_symbol']; ?></SPAN> <INPUT TYPE="TEXT" NAME="shipping2" VALUE="<?php echo $shipping2; ?>" SIZE="6" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMSHIPPINGDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMHANDLING; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $GLOBALS['currency_symbol']; ?></SPAN> <INPUT TYPE="TEXT" NAME="handling" VALUE="<?php echo $handling; ?>" SIZE="8" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMHANDLINGDESC; ?></SPAN>
		</TD>
		</TR>
		
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		
		<?
		
		// Check if user has permission to activate/deactive record
		
		if (pnSecAuthAction(0, 'PayPalCart:Product:Active', "::$pid", ACCESS_EDIT)) {
		
		?>
		
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ACTIVE; if ($active) $activecheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="active" VALUE="1" <?php echo $activecheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ACTIVEITEMDESC; ?></SPAN></TD>
		
		<?
		
		} else {
		
		?>
		
		<TD COLSPAN="2"><INPUT TYPE="HIDDEN" NAME="active" VALUE="<?php echo $active; ?>"></TD>
		
		<?
		
		}
		
		?>
		
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMIMAGE_TH; ?>:</B></SPAN></TD>
		<TD>
		<SELECT NAME="image_th" CLASS="pn-normal" onChange="document.images.imageth.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		<?php echo paypal_admin_imageselectlist($image_th);
		
		  if (!$image_th)
			    $image_th = 'transparent.png'; ?>
		</SELECT>&nbsp;&nbsp;<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $image_th; ?>" name="imageth" alt="" align="top">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMIMAGE_THDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMIMAGE; ?>:</B></SPAN></TD>
		<TD>
		
		<SELECT NAME="image" CLASS="pn-normal" onChange="document.images.image.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		<?php echo paypal_admin_imageselectlist($image); 
		
		 if (!$image)
			    $image = 'transparent.png';
		
		?>
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMIMAGEDESC; ?></SPAN>
		
		</TD>
		</TR>
		
		<TR VALIGN="TOP" ALIGN="CENTER"><TD COLSPAN="2"><BR>
		<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $image; ?>" name="image" alt="" align="top">
		</TD></TR>
		
		</TABLE>
    <BR>
		<DIV ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="SUBMIT" CLASS="pn-normal" STYLE="text-align: center;" VALUE="<?php echo $pagetitle; ?>">
		
		<?php
		// Make cancel URL go to home page if adding item from unset category, else go to category's edit screen
		if (!isset($cid))
		    $cancel_url = pnModURL('PayPalCart', 'admin', 'main');
		else
		    $cancel_url = pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid, 'authid' => $authid));
		
		?>
		
	  &nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo $cancel_url; ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">
			
	  <?php
	
	  // Show delete button if editing a product
		if (isset($pid) && pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_DELETE)) {
	
	  ?>
	
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart','admin','deleteitem', array('pid' => $pid, 'cid' => $cid, 'authid' => $authid)); ?>'" VALUE="<?php echo _PPC_DELETE; ?>">
			
	  <?php
	
	  }
	
	  ?>
		</DIV>
		</FORM>
		
    <?php
		
		CloseTable();

    return ;
}



// Create a new item
function paypalcart_admin_createitem() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');			
    $cid = pnVarCleanFromInput('cid');		
    $prod_name = pnVarCleanFromInput('prod_name');
    $sku = pnVarCleanFromInput('sku');	
    $desc = pnVarCleanFromInput('desc');
    $amount = pnVarCleanFromInput('amount');	
    $option1 = pnVarCleanFromInput('option1');
    $option2 = pnVarCleanFromInput('option2');	
    $shipping = pnVarCleanFromInput('shipping');
    $shipping2 = pnVarCleanFromInput('shipping2');	
    $handling = pnVarCleanFromInput('handling');
    $active = pnVarCleanFromInput('active');	
    $image_th = pnVarCleanFromInput('image_th');
    $image = pnVarCleanFromInput('image');														

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    $item_pid = pnModAPIFunc('PayPalCart', 'admin', 'createitem', array('cid' => $cid, 'prod_name' => $prod_name,
		                                                            'sku' => $sku, 'desc' => $desc, 'amount' => $amount,
																																'option1' => $option1, 'option2' => $option2, 'shipping' => $shipping,
																																'shipping2' => $shipping2, 'handling' => $handling, 'active' => $active,
																																'image_th' => $image_th, 'image' => $image, 'authid' => $authid));
																																
		if ($item_pid)  {
        // Success
        pnSessionSetVar('statusmsg', _PPC_ITEMCREATED);
    }
		
    $items = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $item_pid);		

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $items['cid'], 'authid' => $authid)));
    return true;
}


// Update an item
function paypalcart_admin_updateitem() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');		
    $pid = pnVarCleanFromInput('pid');
    $cid = pnVarCleanFromInput('cid');	
    $old_cid = pnVarCleanFromInput('old_cid');				
    $prod_name = pnVarCleanFromInput('prod_name');
    $sku = pnVarCleanFromInput('sku');	
    $desc = pnVarCleanFromInput('desc');
    $amount = pnVarCleanFromInput('amount');	
    $option1 = pnVarCleanFromInput('option1');
    $option2 = pnVarCleanFromInput('option2');	
    $shipping = pnVarCleanFromInput('shipping');
    $shipping2 = pnVarCleanFromInput('shipping2');	
    $handling = pnVarCleanFromInput('handling');
    $active = pnVarCleanFromInput('active');	
    $image_th = pnVarCleanFromInput('image_th');
    $image = pnVarCleanFromInput('image');														

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'updateitem', array('pid' => $pid, 'cid' => $cid, 'old_cid' => $old_cid, 'prod_name' => $prod_name,
		                                                            'sku' => $sku, 'desc' => $desc, 'amount' => $amount,
																																'option1' => $option1, 'option2' => $option2, 'shipping' => $shipping,
																																'shipping2' => $shipping2, 'handling' => $handling, 'active' => $active,
																																'image_th' => $image_th, 'image' => $image, 'authid' => $authid))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_ITEMUPDATED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid, 'authid' => $authid)));
    return true;
}



// Delete an item
function paypalcart_admin_deleteitem() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');			
    $pid = pnVarCleanFromInput('pid');
    $cid = pnVarCleanFromInput('cid');		
    $confirm = pnVarCleanFromInput('confirm');	
		
    // Check for confirmation
    if (empty($confirm)) {
		
	      if (!pnModAPILoad('PayPalCart', 'admin')){
		        return paypal_admin_error(_ERROR_LOAD);
				}	
				
				$items = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
        extract($items);			
		
        // No confirmation yet - get one
        $output = new pnHTML();
        include('header.php');		
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(paypalcart_admin_deleteconfirm(_PPC_DELETEITEM.': '.$prod_name.' (ID#'.$pid.')',_PPC_CONFIRMITEMDELETE,pnModURL('PayPalCart','admin','deleteitem', array('pid' => $pid, 'cid' => $cid)),pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid,  'authid' => $authid)), $authid));
        $output->SetInputMode(_PNH_PARSEINPUT);
        include('footer.php');						
        return $output->GetOutput();				
    }		
			

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'deleteitem', array('pid' => $pid, 'cid' => $cid))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_ITEMDELETED);
    }

    // Redirect to category edit screen
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid, 'authid' => $authid)));
    return true;
}



// Category edit/add page load
function paypalcart_admin_editcategorymenu() {
		
    $args['authid'] = pnVarCleanFromInput('authid');	
    $args['cid'] = pnVarCleanFromInput('cid');			



    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$args[cid]", ACCESS_EDIT)) {
        paypalcart_admin_error(_PPC_NOAUTH);
        exit;
    }
		
		// Create output object
		$output = new pnHTML();		

    include('header.php');			
		
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_admin_editcategoryform($args));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');
		
    return $output->GetOutput();
		

}



// Form output for category edit/add page
function paypalcart_admin_editcategoryform($args) {

    extract($args);
		
    $authid = pnSecGenAuthKey();			
	 
    if(!pnModAPILoad('PayPalCart', 'admin')){
		    return paypal_admin_error(_ERROR_LOAD);
				}	


    if (!empty($cid)) {
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getcategory', $cid);
        extract($items);	
			  $pagetitle = _PPC_EDITCATEGORY.': '.$cat_name;
			  $action = pnModUrl('PayPalCart', 'admin', 'updatecategory'); 
	  } else {
	      $pagetitle = _PPC_ADDCATEGORY;
			  $action = pnModUrl('PayPalCart', 'admin', 'createcategory');
				$active = '1';
				$itemcolumns = '3';				
				$cat_name = _PPC_CATEGORYNAME; 				  
    }

    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo $pagetitle; ?></SPAN>
    
		<?php
		
		CloseTable2();

		paypalcart_admin_submenu($authid);		
		
		?>		

		</DIV>
		
    <FORM METHOD="POST" ACTION="<?php echo $action; ?>">
    <INPUT TYPE="HIDDEN" NAME="authid" VALUE="<?php echo $authid; ?>">
    <INPUT TYPE="HIDDEN" NAME="cid" VALUE="<?php echo $cid; ?>">		
		<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="8">
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD WIDTH="33%"><SPAN CLASS="pn-normal"><B><?php echo _PPC_CATEGORYNAME; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="cat_name" VALUE="<?php echo $cat_name; ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CATEGORYNAMEDESC; ?></SPAN></TD>
		</TR>
		
	
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_CATEGORYDESC; ?>:</B></SPAN></TD>
		<TD><TEXTAREA NAME="desc" ROWS="3" STYLE="width: 100%;" CLASS="pn-normal"><?php echo $desc; ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CATEGORYDESCDESC; ?></SPAN></TD>
		</TR>
		
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ITEMCOLUMNS; ?>:</B></SPAN></TD>
		<TD>
		<SELECT NAME="itemcolumns" CLASS="pn-normal"><?php echo paypal_admin_numberelectlist(1,8,$itemcolumns); ?>
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ITEMCOLUMNSDESC; ?></SPAN>
		</TD>
		</TR>
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		
		<?
		
		// Check if user has permission to activate/deactive record
		
		if (pnSecAuthAction(0, 'PayPalCart:Category:Active', "::$cid", ACCESS_EDIT)) {
		
		?>
		
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_ACTIVE; if ($active) $activecheck = 'CHECKED="CHECKED"'; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="CHECKBOX" NAME="active" VALUE="1" <?php echo $activecheck; ?> CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_ACTIVECATDESC; ?></SPAN></TD>
		
		<?
		
		} else {
		
		?>
		
		<TD COLSPAN="2"><INPUT TYPE="HIDDEN" NAME="active" VALUE="<?php echo $active; ?>"></TD>
		
		<?
		
		}
		
		?>
		
		</TR>		
		
				
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_CATEGORYIMAGE; ?>:</B></SPAN></TD>
		<TD><SELECT NAME="image" CLASS="pn-normal" onChange="document.images.caticon.src= '<?php echo pnModGetVar('PayPalCart', 'imagepath'); ?>' + this.options[this.selectedIndex].value">
		<OPTION VALUE="transparent.png"><?php echo _PPC_NOIMAGE; ?></OPTION>		
		<?php echo paypal_admin_imageselectlist($image); 
		
		 if (!$image)
			    $image = 'transparent.png';
		
		?>
		</SELECT>&nbsp;&nbsp;<img src="<?php echo pnModGetVar('PayPalCart', 'imagepath') . $image; ?>" name="caticon" alt="" align="top">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_CATEGORYIMAGEDESC; ?></SPAN>
		</TD>
		
		
		
		
		</TR>
	
		</TABLE>
    <BR><DIV ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="SUBMIT" CLASS="pn-normal" STYLE="text-align: center;" VALUE="<?php echo $pagetitle; ?>">
		
	&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart', 'admin', 'main'); ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">


	  <?php
	
    // Output delete button if editing a category	
	  if (isset($cid) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_DELETE)) {
	
	      ?>
	
	    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart','admin','deletecategory', array('cid' => $cid,'authid' => $authid)); ?>'" VALUE="<?php echo _PPC_DELETE; ?>">
			
	      <?php
	  
		}
	  
		?>	
		</DIV><BR>
		</FORM>
		
		<?php
		
	  if (isset($cid)) {		
		
		    ?>
		
		    <DIV ALIGN="CENTER">
		
		    <?php
		
		    // Get a list of items in this category, and generate an item edit table
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $ppc_items_table = $pntable['paypalcart_items'];
        $ppc_items_column = &$pntable['paypalcart_items_column'];
        // Get the option table & column names		
        $ppc_options_table = $pntable['paypalcart_options'];
        $ppc_options_column = &$pntable['paypalcart_options_column'];				
		
        $sql = "SELECT $ppc_items_column[pid], $ppc_items_column[sku], $ppc_items_column[name], $ppc_items_column[amount], $ppc_items_column[active], $ppc_items_column[option1], $ppc_items_column[option2] FROM $ppc_items_table WHERE $ppc_items_column[cid] = $cid ORDER BY $ppc_items_column[order]";
 		    $result = $dbconn->Execute($sql);
		
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
		
		    // $itemcount = $result->PO_RecordCount();	
		    for (; !$result->EOF; $result->MoveNext()) {
		
		        list($pid, $sku, $prod_name, $amount, $active, $option1, $option2) = $result->fields;
				
				    if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT)) {
                $itemcount++;
            }		
		
		    }				
		
        OpenTable2();
		
        ?>
		
		    <SPAN CLASS="pn-title"><?php echo _PPC_EDITITEMS; ?></SPAN>
    
		    <?php
		
		    CloseTable2();
		
        ?>

		    </DIV>		
		
		    <?php
		
		    if ($itemcount) {
				
				    $result = $dbconn->Execute($sql);		
		
		        echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="5" WIDTH="100%">';	
		        echo '<tr class="pn-normal"><th width="30" colspan="2">'._PPC_ORDER.'</th><th width="30">'._PPC_ACTIVE.'</th><th width="30">'._PPC_ID.'</th><th>'._PPC_ITEMSKU.'</th><th>'._PPC_ITEMNAME.'</th><th>'._PPC_ITEMAMOUNT.'</th><th>'._PPC_ITEMATTRIBUTES.'</th><th width="30">&nbsp;</th></tr>';				
		
            for (; !$result->EOF; $result->MoveNext()) {
					
		            list($pid, $sku, $prod_name, $amount, $active, $option1, $option2) = $result->fields;
								
				        if (!pnSecAuthAction(0, 'PayPalCart:Product:', "::$pid", ACCESS_EDIT)) {
                    continue;
                }										
								
								$count++;
								
						$activecheck = '';
						
						// Set flag to output hyperlinks if permissions to edit active
						if (pnSecAuthAction(0, 'PayPalCart:Product:Active', "::$pid", ACCESS_EDIT))
						    $activepermflag = 1;
			
            if ($active == '1') {
						    if ($activepermflag)
			              $activecheck .= '<A HREF="'.pnModURL('PayPalCart','admin','changeitemstatus', array('cid' => $cid, 'pid' => $pid, 'status' => 'inactive', 'authid' => $authid)).'">';

                $activecheck .= '<IMG SRC="modules/PayPalCart/pnimages/active.gif" ALT="'._PPC_DEACTIVATE.'" BORDER="0">';
							
			      } else {
						    if ($activepermflag)
			              $activecheck .= '<A HREF="'.pnModURL('PayPalCart','admin','changeitemstatus', array('cid' => $cid, 'pid' => $pid, 'status' => 'active', 'authid' => $authid)).'">';
		            
								$activecheck .= '<IMG SRC="modules/PayPalCart/pnimages/inactive.gif" ALT="'._PPC_ACTIVATE.'" BORDER="0">';								
            }
						
						if ($activepermflag)
			          $activecheck .= '</A>';
						
            $activepermflag = 0;								
								
			          echo '<tr class="pn-normal">';
								
								echo '<td align="center">';
								
						    
						    // Check permissions for ordering
						    if (pnSecAuthAction(0, 'PayPalCart:Product:Order', "::$pid", ACCESS_EDIT)) {								
								
								    // Output up arrow
						        if ($count !=1) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','decitem',array('cid' => $cid , 'pid' => $pid , 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up.gif" ALT="<?php echo _PPC_MOVEUP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
								
						        // Output down arrow
						        if ($count < $itemcount) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','incitem', array('cid' => $cid , 'pid' => $pid , 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down.gif" ALT="<?php echo _PPC_MOVEDOWN; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }	
										
								}											
								
								echo '&nbsp;</td>';
								
								echo '<td align="center">';
								
						    // Check permissions for ordering
						    if (pnSecAuthAction(0, 'PayPalCart:Product:Order', "::$pid", ACCESS_EDIT)) {											
								
						        // Output up to top arrow
						        if ($count !=1) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','decitem',array('cid' => $cid , 'pid' => $pid , 'totop' => '1', 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up2.gif" ALT="<?php echo _PPC_MOVETOTOP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
								
						        // Output down to bottom arrow
						        if ($count < $itemcount) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','incitem', array('cid' => $cid , 'pid' => $pid , 'tobot' => '1', 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down2.gif" ALT="<?php echo _PPC_MOVETOBOTTOM; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
										
								}												
								
								echo '&nbsp;</td>';								
								
								echo '<td align="center">'.$activecheck.'&nbsp;</td><td>'.$pid.'</td><td>'.$sku.'&nbsp;</td><td>'.$prod_name.'</td><td>'.$GLOBALS['currency_symbol'].$amount.'</td><td><span class="pn-sub">';
								
								$labelcount = 0;
								
								$sql = "SELECT $ppc_options_column[name] FROM $ppc_options_table WHERE $ppc_options_column[oid] = '$option1'";
 		            $result2 = $dbconn->Execute($sql);

		            list($opt_name) = $result2->fields;
								
								if ($opt_name) {
								    echo '&middot;&nbsp;'.$opt_name;
								    $labelcount++;
								}
								
								$sql = "SELECT $ppc_options_column[name] FROM $ppc_options_table WHERE $ppc_options_column[oid] = '$option2'";
 		            $result2 = $dbconn->Execute($sql);

		            list($opt_name) = $result2->fields;
								if ($opt_name) {								
								    if ($labelcount)
										    echo '<BR>';
								    echo '&middot;&nbsp;'.$opt_name;
                }										
												
								
								echo '&nbsp;</span></td><td align="center">';
								
								if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT))
								    echo '[&nbsp;<a href="'. pnModURL('PayPalCart','admin','edititemmenu', array('pid' => $pid, 'authid' => $authid)) .'" CLASS="pn-normal">'._PPC_EDIT.'</a>&nbsp;]';
								else
								    echo '&nbsp;';
								
								echo '</td></tr>';

            }	
		
		        echo '</TABLE>';						

           $result->Close();	
		
		    } else {
		
		    ?>
		
		    
		    <DIV ALIGN="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOITEMSINTHISCAT; ?></SPAN></DIV>
		
		    <?php
		
		    }  // end if->itemcount check...
		
   	if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT) && pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::", ACCESS_ADD)) 
        echo '<BR><DIV ALIGN="CENTER"><SPAN CLASS="pn-normal">[&nbsp;<A HREF="'.pnModURL('PayPalCart','admin','edititemmenu', array('authid' => $authid, 'cid' => $cid)).'" CLASS="pn-normal">'._PPC_ADDITEM2CAT.'</A>&nbsp;]</SPAN></DIV>';
		

		
		} // End if cid set
		
		CloseTable();
 
    return ;
}



// Create a new category
function paypalcart_admin_createcategory() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');		
    $cat_name = pnVarCleanFromInput('cat_name');
    $desc = pnVarCleanFromInput('desc');
    $itemcolumns = pnVarCleanFromInput('itemcolumns');		
    $active = pnVarCleanFromInput('active');	
    $image = pnVarCleanFromInput('image');														

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'createcategory', array('cid' => $cid, 'cat_name' => $cat_name, 'desc' => $desc,
																																'itemcolumns' => $itemcolumns, 'active' => $active,'image' => $image))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_CATEGORYCREATED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Update a category
function paypalcart_admin_updatecategory() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');		
    $cat_name = pnVarCleanFromInput('cat_name');
    $desc = pnVarCleanFromInput('desc');	
    $active = pnVarCleanFromInput('active');				
    $itemcolumns = pnVarCleanFromInput('itemcolumns');	
    $image = pnVarCleanFromInput('image');														

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'updatecategory', array('cid' => $cid, 'cat_name' => $cat_name, 'desc' => $desc,
																																'itemcolumns' => $itemcolumns, 'active' => $active, 'image' => $image))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_CATEGORYUPDATED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}

// Change category status (active/inactive)
function paypalcart_admin_changecategorystatus() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');		
    $status = pnVarCleanFromInput('status');
		
		if ($status == 'active')
        $message = _PPC_CATEGORYACTIVATED;
		else
        $message = _PPC_CATEGORYDEACTIVATED;						

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'changecategorystatus', array('cid' => $cid, 'status' => $status))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Change item status (active/inactive)
function paypalcart_admin_changeitemstatus() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');	
    $pid = pnVarCleanFromInput('pid');				
    $status = pnVarCleanFromInput('status');
		
		if ($status == 'active')
        $message = _PPC_ITEMACTIVATED;
		else
        $message = _PPC_ITEMDEACTIVATED;						

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'changeitemstatus', array('pid' => $pid, 'status' => $status))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid, 'authid' => $authid)));
    return true;
}



// Delete a category
function paypalcart_admin_deletecategory() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');				
    $cid = pnVarCleanFromInput('cid');
    $confirm = pnVarCleanFromInput('confirm');	
		
    // Check for confirmation
    if (empty($confirm)) {
		
	      if (!pnModAPILoad('PayPalCart', 'admin')){
		        return paypal_admin_error(_ERROR_LOAD);
				}	
				
				$items = pnModAPIFunc('PayPalCart', 'admin', 'getcategory', $cid);
        extract($items);			

        // No confirmation yet - get one
        $output = new pnHTML();
        include('header.php');		
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(paypalcart_admin_deleteconfirm(_PPC_DELETECATEGORY.': '.$cat_name.' (ID#'.$cid.')',_PPC_CONFIRMCATEGORYDELETE,pnModURL('PayPalCart','admin','deletecategory', array('cid' => $cid)),pnModURL('PayPalCart','admin','main'), $authid));
        $output->SetInputMode(_PNH_PARSEINPUT);
        include('footer.php');						
        return $output->GetOutput();
    }		
			

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'deletecategory', array('cid' => $cid))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_CATEGORYDELETED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Option edit/add page load
function paypalcart_admin_editoptionmenu() {
		
    $args['authid'] = pnVarCleanFromInput('authid');	
    $args['oid'] = pnVarCleanFromInput('oid');			


    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$args[oid]", ACCESS_EDIT)) {
        paypalcart_admin_error(_PPC_NOAUTH);
        exit;
    }
		
		// Create output object
		$output = new pnHTML();		

    include('header.php');			
		
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_admin_editoptionform($args));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');	
		
    return $output->GetOutput();
		

}


// Form output for option edit page
function paypalcart_admin_editoptionform($args) {

    extract($args);
		
    $authid = pnSecGenAuthKey();		
	 
    if(!pnModAPILoad('PayPalCart', 'admin')){
		    return paypal_admin_error(_ERROR_LOAD);
				}	

    if (!empty($oid)) {
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getoption', $oid);
        extract($items);	
			  $pagetitle = _PPC_EDITOPTION.': '.$label.' ('._PPC_ID.' '.$oid.')';
				$buttontitle = _PPC_EDITOPTION.': '.$label;
			  $action = pnModUrl('PayPalCart', 'admin', 'updateoption'); 
	  } else {
	      $pagetitle = _PPC_ADDOPTION;
	      $buttontitle = _PPC_ADDOPTION;				
				$opt_name = _PPC_OPTIONNAME;
				$label = _PPC_OPTIONLABEL;				
			  $action = pnModUrl('PayPalCart', 'admin', 'createoption'); 				  
    }

    // Add a new group menu
    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo $pagetitle; ?></SPAN>
    
		<?php
		
		CloseTable2();

		paypalcart_admin_submenu($authid);		
		
    ?>

		</DIV>
		
    <FORM METHOD="POST" ACTION="<?php echo $action; ?>">
    <INPUT TYPE="HIDDEN" NAME="authid" VALUE="<?php echo $authid; ?>">
    <INPUT TYPE="HIDDEN" NAME="oid" VALUE="<?php echo $oid; ?>">		
		<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="8">
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD WIDTH="33%"><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONNAME; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="opt_name" VALUE="<?php echo $opt_name; ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_OPTIONNAMEDESC; ?></SPAN></TD>
		</TR>
		
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONLABEL; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="label" VALUE="<?php echo $label; ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_OPTIONLABELDESC; ?></SPAN></TD>
		</TR>		

				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONSTYLE; ?>:</B></SPAN>
			</TD>
		<TD>
		
		<SELECT NAME="style" CLASS="pn-normal">
		
		<?php echo paypal_admin_arrayselectlist($GLOBALS['ppc_optionstyle'], $style); ?>
		
		</SELECT>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_OPTIONSTYLEDESC; ?></SPAN>
		
		</TD>
		</TR>

		
	
				<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONDESC; ?>:</B></SPAN></TD>
		<TD><TEXTAREA NAME="desc" ROWS="2" STYLE="width: 100%;" CLASS="pn-normal"><?php echo $desc; ?></TEXTAREA>
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_OPTIONDESCDESC; ?></SPAN></TD>
		</TR>
		
		</TABLE>
    <BR><DIV ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="SUBMIT" CLASS="pn-normal" STYLE="text-align: center;" VALUE="<?php echo $buttontitle; ?>">
		
		
	  &nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart', 'admin', 'main'); ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">


	  <?php
	  
		// Output delete button if editing an option
		if (isset($oid) && pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_DELETE)) {
	
	      ?>
	
	      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart','admin','deleteoption', array('oid' => $oid,'authid' => $authid)); ?>'" VALUE="<?php echo _PPC_DELETE; ?>">
			
	  <?php
	  
		}
	  
		?>	
		</DIV>
		</FORM>
		
		<?php
		
		if (isset($oid)) {
		
		    ?>
		
		    <DIV ALIGN="CENTER">
		
		    <?php
		
        // Get list of option values for this option and output an edit table
		    list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $ppc_optionval_table = $pntable['paypalcart_option_values'];
        $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];
		
        $sql = "SELECT $ppc_optionval_column[vid], $ppc_optionval_column[value] FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid] = $oid ORDER BY $ppc_optionval_column[order]";
 		    $result = $dbconn->Execute($sql);
		
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
				
		    // $optioncount = $result->PO_RecordCount();	
		    for (; !$result->EOF; $result->MoveNext()) {
		
		        list($vid, $value) = $result->fields;
				
				    if (pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_EDIT)) {
                $optioncount++;
            }		
		
		    }								
		
        OpenTable2();
		
        ?>
		
		    <SPAN CLASS="pn-title"><?php echo _PPC_EDITOPTIONVALS; ?></SPAN>
    
		    <?php
		
		    CloseTable2();
		
        ?>

		    </DIV>		
		
		    <?php
		
		    if ($optioncount) {		
		
		        echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="5" WIDTH="100%">';	
		        echo '<tr class="pn-normal"><th width="30" colspan="2">'._PPC_ORDER.'</th><th width="30">'._PPC_ID.'</th><th colspan="2">'._PPC_OPTIONVALUE.'</th></tr>';				
		
		 		    $result = $dbconn->Execute($sql);
		
            for (; !$result->EOF; $result->MoveNext()) {
					
		            list($vid, $value) = $result->fields;
								
				        if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_EDIT)) {
                    continue;
                }										
								
								$count++; 
								
  	    		    echo '<tr class="pn-normal">';
								
								echo '<td align="center">';
									
						    // Check permissions for ordering
						    if (pnSecAuthAction(0, 'PayPalCart:OptionValue:Order', "::$vid", ACCESS_EDIT)) {			
								
								    // Output up arrow
						        if ($count !=1) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','decoptionval',array('oid' => $oid , 'vid' => $vid , 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up.gif" ALT="<?php echo _PPC_MOVEUP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
								
					
						        // Output down arrow
						        if ($count < $optioncount) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','incoptionval', array('oid' => $oid , 'vid' => $vid , 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down.gif" ALT="<?php echo _PPC_MOVEDOWN; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
										
								}														
								
								echo '&nbsp;</td>';
								echo '<td align="center">';
								
						    // Check permissions for ordering
						    if (pnSecAuthAction(0, 'PayPalCart:OptionValue:Order', "::$vid", ACCESS_EDIT)) {																		
									
						        // Output up to top arrow
						        if ($count !=1) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','decoptionval',array('oid' => $oid , 'vid' => $vid  , 'totop' => '1', 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/up2.gif" ALT="<?php echo _PPC_MOVETOTOP; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
								
					
						        // Output down to bottom arrow
						        if ($count < $optioncount) {
						
						            ?><A HREF="<?php echo pnModURL('PayPalCart','admin','incoptionval', array('oid' => $oid , 'vid' => $vid , 'tobot' => '1', 'authid' => $authid)); ?>"><IMG SRC="modules/PayPalCart/pnimages/down2.gif" ALT="<?php echo _PPC_MOVETOBOTTOM; ?>" ALIGN="ABSMIDDLE" BORDER="0" HSPACE="2"></A><?php
						
						        }
										
								}														
								
								echo '&nbsp;</td>';									
								
								echo '<td>'.$vid.'</td><td>'.$value.'</td><td align="center">[&nbsp;<a href="'. pnModURL('PayPalCart','admin','editoptionvalmenu', array('vid' => $vid, 'oid' => $oid, 'authid' => $authid)) .'" CLASS="pn-normal">'._PPC_EDIT.'</a>&nbsp;]</td></tr>';
				
            }	
		
		    echo '</TABLE>';						
        
				$result->Close();	
		
		    } else {
		
		        ?>
		
		        
		        <DIV ALIGN="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOVALSINTHISOPTION; ?></SPAN></DIV>
		
		    <?php
		
		    }  // end if->optioncount check...
		

				if (pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT) && pnSecAuthAction(0, 'PayPalCart:OptionVal:Edit', "::", ACCESS_ADD)) 
		        echo '<BR><DIV ALIGN="CENTER"><SPAN CLASS="pn-normal">[&nbsp;<A HREF="'.pnModURL('PayPalCart','admin','editoptionvalmenu', array('authid' => $authid, 'oid' => $oid)).'" CLASS="pn-normal">'._PPC_ADDVAL2OPTION.'</A>&nbsp;]</SPAN></DIV>';
		

	
		} // End if set oid loop
		
		CloseTable();
 
    return ;
}



// Create a new option
function paypalcart_admin_createoption() {

    // Get parameters
    $opt_name = pnVarCleanFromInput('opt_name');
    $label = pnVarCleanFromInput('label');		
    $style = pnVarCleanFromInput('style');			
    $desc = pnVarCleanFromInput('desc');

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'createoption', array('opt_name' => $opt_name, 'label' => $label, 'style' => $style, 'desc' => $desc))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONCREATED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Update an option
function paypalcart_admin_updateoption() {

    // Get parameters
    $oid = pnVarCleanFromInput('oid');		
    $opt_name = pnVarCleanFromInput('opt_name');
    $label = pnVarCleanFromInput('label');	
    $style = pnVarCleanFromInput('style');				
    $desc = pnVarCleanFromInput('desc');													

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'updateoption', array('oid' => $oid, 'opt_name' => $opt_name, 'label' => $label, 'style' => $style, 'desc' => $desc))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONUPDATED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}



// Delete an option
function paypalcart_admin_deleteoption() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');			
    $oid = pnVarCleanFromInput('oid');
    $confirm = pnVarCleanFromInput('confirm');	
		
    // Check for confirmation
    if (empty($confirm)) {
		
	      if (!pnModAPILoad('PayPalCart', 'admin')){
		        return paypal_admin_error(_ERROR_LOAD);
				}	
				
				$items = pnModAPIFunc('PayPalCart', 'admin', 'getoption', $oid);
        extract($items);		
						
        // No confirmation yet - get one
        $output = new pnHTML();
        include('header.php');		
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(paypalcart_admin_deleteconfirm(_PPC_DELETEOPTION.': '.$opt_name.' (ID#'.$oid.')',_PPC_CONFIRMOPTIONDELETE, pnModURL('PayPalCart','admin','deleteoption', array('oid' => $oid)),pnModURL('PayPalCart','admin','main'), $authid));
        $output->SetInputMode(_PNH_PARSEINPUT);
        include('footer.php');						
        return $output->GetOutput();					
    }		
			

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'deleteoption', array('oid' => $oid))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONDELETED);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}



// Option value edit/add page load
function paypalcart_admin_editoptionvalmenu() {
		
    $args['authid'] = pnVarCleanFromInput('authid');	
    $args['vid'] = pnVarCleanFromInput('vid');	
    $args['oid'] = pnVarCleanFromInput('oid');			

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$args[vid]", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$args[oid]", ACCESS_EDIT)) {
        paypalcart_admin_error(_PPC_NOAUTH);
        exit;
    }
		
		// Create output object
		$output = new pnHTML();		

    include('header.php');			
		
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_admin_editoptionvalform($args));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');	
		
    // Return the output that has been generated by this function
    return $output->GetOutput();
	
}


// Form output for option value edit/add page
function paypalcart_admin_editoptionvalform($args) {

    extract($args);
		
    $authid = pnSecGenAuthKey();		
	 
    if(!pnModAPILoad('PayPalCart', 'admin')){
		    return paypal_admin_error(_ERROR_LOAD);
				}	

    if (!empty($vid)) {
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);
        extract($items);	
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getoption', $oid);
        extract($items);					
			  $pagetitle = _PPC_EDITOPTIONVAL.': '.$value;
			  $action = pnModUrl('PayPalCart', 'admin', 'updateoptionval'); 
	  } else {
	      $items = pnModAPIFunc('PayPalCart', 'admin', 'getoption', $oid);
        extract($items);				
	      $pagetitle = _PPC_ADDOPTIONVAL;
			  $action = pnModUrl('PayPalCart', 'admin', 'createoptionval'); 				  
    }

    OpenTable();
		
		?>
		
		<DIV ALIGN="CENTER">
		
		<?php
		
    OpenTable2();
		
    ?>
		
		<SPAN CLASS="pn-title"><?php echo $pagetitle; ?></SPAN>
    
		<?php
		
		CloseTable2();
		
    paypalcart_admin_submenu($authid);				
		
    ?>

		</DIV>
		
    <FORM METHOD="POST" ACTION="<?php echo $action; ?>">
    <INPUT TYPE="HIDDEN" NAME="authid" VALUE="<?php echo $authid; ?>">
    <INPUT TYPE="HIDDEN" NAME="oid" VALUE="<?php echo $oid; ?>">			
    <INPUT TYPE="HIDDEN" NAME="vid" VALUE="<?php echo $vid; ?>">		
		<TABLE>
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD WIDTH="33%"><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONNAME; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $opt_name; ?></SPAN></TD>
		</TR>		
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONLABEL; ?>:</B></SPAN></TD>
		<TD><SPAN CLASS="pn-normal"><?php echo $label; ?></SPAN></TD>
		</TR>				
		
		<TR VALIGN="TOP" ALIGN="LEFT">
		<TD><SPAN CLASS="pn-normal"><B><?php echo _PPC_OPTIONVALUE; ?>:</B></SPAN></TD>
		<TD><INPUT TYPE="TEXT" NAME="value" VALUE="<?php echo $value; ?>" SIZE="40" CLASS="pn-normal">
		<BR><SPAN CLASS="pn-sub"><?php echo _PPC_OPTIONVALUEDESC; ?></SPAN></TD>
		</TR>
		
		</TABLE>
    <BR><DIV ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="SUBMIT" CLASS="pn-normal" STYLE="text-align: center;" VALUE="<?php echo $pagetitle; ?>">
		
		
	&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid, 'authid' => $authid)); ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">


	  <?php
		
	  // Output delete button if editing an option value
		if (isset($vid) && pnSecAuthAction(0, 'PayPalCart:OptionVal:Edit', "::$vid", ACCESS_DELETE)) {
	
	      ?>
	
	      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo pnModURL('PayPalCart','admin','deleteoptionval', array('oid' => $oid, 'vid' => $vid, 'authid' => $authid)); ?>'" VALUE="<?php echo _PPC_DELETE; ?>">
			
	      <?php
	  }
		
	  ?>	</DIV>
		
		</FORM>
		
	  <?php
		
		CloseTable();
 
    return ;
}



// Create a new option value
function paypalcart_admin_createoptionval() {

    // Get parameters
    $oid = pnVarCleanFromInput('oid');
    $value = pnVarCleanFromInput('value');		

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'createoptionval', array('oid' => $oid, 'value' => $value))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONVALCREATED);
    }

		
    // Redirect to option edit screen
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid, 'authid' => $authid)));
    return true;
}


// Update an option value
function paypalcart_admin_updateoptionval() {

    // Get parameters
    $oid = pnVarCleanFromInput('oid');
    $vid = pnVarCleanFromInput('vid');		
    $value = pnVarCleanFromInput('value');												

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('statusmsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'updateoptionval', array('oid' => $oid, 'vid' => $vid, 'value' => $value))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONVALUPDATED);
    }

    // Redirect to option edit screen
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid, 'authid' => $authid)));
    return true;
}



// Delete an option value
function paypalcart_admin_deleteoptionval() {

    // Get parameters
    $authid = pnVarCleanFromInput('authid');		
    $oid = pnVarCleanFromInput('oid');
    $vid = pnVarCleanFromInput('vid');	
    $confirm = pnVarCleanFromInput('confirm');	
		
    // Check for confirmation
    if (empty($confirm)) {
		
	      if (!pnModAPILoad('PayPalCart', 'admin')){
		        return paypal_admin_error(_ERROR_LOAD);
				}	
				
				$items = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);
        extract($items);				
		
        // No confirmation yet - get one
        $output = new pnHTML();
        include('header.php');		
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(paypalcart_admin_deleteconfirm(_PPC_DELETEOPTIONVAL.': '.$value.' (ID#'.$vid.')',_PPC_CONFIRMOPTIONVALDELETE, pnModURL('PayPalCart','admin','deleteoptionval', array('vid' => $vid, 'oid' => $oid)),pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid, 'authid' => $authid)), $authid));
        $output->SetInputMode(_PNH_PARSEINPUT);
        include('footer.php');						
        return $output->GetOutput();						
    }		
			

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'deleteoptionval', array('vid' => $vid))) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_OPTIONVALDELETED);
    }

    // Redirect to option edit screen
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid, 'authid' => $authid)));
    return true;
}


// ORDERING FUNCTIONS

// Move category down
function paypalcart_admin_inccategory() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');
    $tobot = pnVarCleanFromInput('tobot');
		
		if ($tobot)
		   $message = _PPC_CATEGORYMOVEDTOBOTTOM;
		else
		   $message = _PPC_CATEGORYMOVEDDOWN;

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'inccategory', array('cid' => $cid, 'tobot' => $tobot))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Move category up
function paypalcart_admin_deccategory() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');
    $totop = pnVarCleanFromInput('totop');	
		
		if ($totop)
		   $message = _PPC_CATEGORYMOVEDTOTOP;
		else
		   $message = _PPC_CATEGORYMOVEDUP;				

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'deccategory', array('cid' => $cid, 'totop' => $totop))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}


// Move item down
function paypalcart_admin_incitem() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');
    $pid = pnVarCleanFromInput('pid');		
    $tobot = pnVarCleanFromInput('tobot');	
		
		if ($tobot)
		   $message = _PPC_ITEMMOVEDTOBOTTOM;
		else
		   $message = _PPC_ITEMMOVEDDOWN;				

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'incitem', array('pid' => $pid, 'tobot' => $tobot))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid)));
    return true;
}


// Move item up
function paypalcart_admin_decitem() {

    // Get parameters
    $cid = pnVarCleanFromInput('cid');
    $pid = pnVarCleanFromInput('pid');
    $totop = pnVarCleanFromInput('totop');	
		
		if ($totop)
		   $message = _PPC_ITEMMOVEDTOTOP;
		else
		   $message = _PPC_ITEMMOVEDUP;					

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'decitem', array('pid' => $pid, 'totop' => $totop))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editcategorymenu', array('cid' => $cid)));
    return true;
}


// Move option value down
function paypalcart_admin_incoptionval() {

    // Get parameters
    $oid = pnVarCleanFromInput('oid');
    $vid = pnVarCleanFromInput('vid');
    $tobot = pnVarCleanFromInput('tobot');	
		
		if ($tobot)
		   $message = _PPC_OPTIONVALMOVEDTOBOTTOM;
		else
		   $message = _PPC_OPTIONVALMOVEDDOWN;						

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'incoptionval', array('vid' => $vid, 'tobot' => $tobot))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid)));
    return true;
}


// Move option val up
function paypalcart_admin_decoptionval() {

    // Get parameters
    $oid = pnVarCleanFromInput('oid');
    $vid = pnVarCleanFromInput('vid');	
    $totop = pnVarCleanFromInput('totop');	
		
		if ($totop)
		   $message = _PPC_OPTIONVALMOVEDTOTOP;
		else
		   $message = _PPC_OPTIONVALMOVEDUP;				

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'decoptionval', array('vid' => $vid, 'totop' => $totop))) {
        // Success
        pnSessionSetVar('statusmsg', $message);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'editoptionmenu', array('oid' => $oid)));
    return true;
}


// Image upload function
function paypalcart_admin_imageupload() {

    // Get parameters
		$img = $_FILES['img'];
		
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');
		
    if (file_exists(pnModGetVar('PayPalCart', 'imagepath').'/'.$img['name'])) {
		    $overwrite_warning = '<BR>'._PPC_IMAGEOVERWRITTEN;
		}	

    // Pass to API
    if (pnModAPIFunc('PayPalCart', 'admin', 'imageupload', $img)) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_IMAGEUPLOADED.': '.$img['name'].$overwrite_warning);
    }

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
}

// Purge unused images function
function paypalcart_admin_imagepurge() {

    // Get parameters
    $confirm = pnVarCleanFromInput('confirm');	
    $authid = pnVarCleanFromInput('authid');			
		
    // Check for confirmation
    if (empty($confirm)) {
        // No confirmation yet - get one
        $output = new pnHTML();
        include('header.php');		
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(paypalcart_admin_deleteconfirm(_PPC_IMAGEPURGE,_PPC_CONFIRMIMAGEPURGE, pnModURL('PayPalCart','admin','imagepurge'),pnModURL('PayPalCart', 'admin', 'main'), $authid));
        $output->SetInputMode(_PNH_PARSEINPUT);
        include('footer.php');						
        return $output->GetOutput();						
    }		
			

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
        return true;
    }

    // Load in API
    pnModAPILoad('PayPalCart', 'admin');

		$images_purged = pnModAPIFunc('PayPalCart', 'admin', 'imagepurge');
		
    // Pass to API
    if ($images_purged) {
        // Success
        pnSessionSetVar('statusmsg', _PPC_IMAGESPURGED.' ('.$images_purged['count'].'): <SPAN STYLE="font-weight:normal;">'.$images_purged['images'].'</SPAN>');
    } else {
       pnSessionSetVar('statusmsg', _PPC_IMAGESNOPURGED);	
		}

    // Redirect
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
    return true;
		
}


// Create a select list of available categories
function paypalcart_admin_categoryselectlist($selected = '') {

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
		
    $sql = "SELECT $ppc_categories_column[cid], $ppc_categories_column[name] FROM $ppc_categories_table ORDER BY $ppc_categories_column[order]";
 		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        list($cid, $cat_name) = $result->fields;
	      $output .= '<OPTION VALUE="'.$cid.'"';
				
        if ($cid == $selected)
				    $output .= ' SELECTED="SELECTED"';
				
				$output .= '>'.$cat_name.'</OPTION>';	
    }							

    $result->Close();		
    return $output;
}


// Create a select list of available options
function paypalcart_admin_optionselectlist($selected = '0') {

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];
		
    $sql = "SELECT $ppc_options_column[oid], $ppc_options_column[name], $ppc_options_column[label] FROM $ppc_options_table ORDER BY $ppc_options_column[label]";
 		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        list($oid, $opt_name, $label) = $result->fields;
				
		    if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT)) {
            continue;
        }				
				
	      $output .= '<OPTION VALUE="'.$oid.'"';
				
        if ($oid == $selected)
				    $output .= ' SELECTED="SELECTED"';
				
				$output .= '>'.$opt_name.' ('.$label.')</OPTION>';	
    }							

    $result->Close();		
    return $output;
}

// Create an image select list of the specified image directory
function paypal_admin_imageselectlist($selected) {

    // Fetch icon images from directory
    $handle = opendir(pnModGetVar('PayPalCart', 'imagepath'));
				
		while ($file = readdir($handle)) {
        $filelist[] = $file;
    }
				
		asort($filelist);		
		
    while (list ($key, $file) = each ($filelist)) {
        
				ereg(".gif|.jpg|.png", $file);
        if ($file != '.' && $file != '..' && $file != 'index.html' && $file != 'transparent.png') {
            $output .=  '<option value="'.$file.'"';
                if ($file == $selected) {
                    $output .=  " selected";
                } 
                $output .=  '>'.$file.'</option>';
        } 
    } 
				
    return $output;			

}


// Create a select list from a variable array
function paypal_admin_arrayselectlist($array, $selected) {


    while (list($key,$value) = each($array)) {
        $output .= '<OPTION VALUE="'.$key.'"';
	
    if ($key == $selected)
        $output .= ' SELECTED="SELECTED"';			
			
		$output .= '>'.$value.'</OPTION>';			
    }		
		
    return $output;
}

// Create a select list of a range of numbers
function paypal_admin_numberelectlist($rangestart, $rangeend, $selected) {

    $array = range($rangestart, $rangeend);

    while (list($key,$value) = each($array)) {
        $output .= '<OPTION VALUE="'.$value.'"';
	
    if ($value == $selected)
        $output .= ' SELECTED="SELECTED"';			
			
		$output .= '>'.$value.'</OPTION>';			
    }		
		
    return $output;
}

// Output the administration submenu
function paypalcart_admin_submenu($authid) {

		$statusmsg = pnGetStatusMsg();
		
		if ($statusmsg) {
		    ?>
				
				<BR><SPAN CLASS="pn-normal"><B><?php echo $statusmsg; ?></B></SPAN><BR>
				
				<?php

		}

		?>
		
		<BR><SPAN CLASS="pn-normal">[&nbsp;
		
		<A HREF="<?php echo pnModURL('PayPalCart','admin','main', array('authid' => $authid)); ?>" CLASS="pn-normal"><?php echo _PPC_MAIN ?></A> 
		
		<?
		
		if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', '::', ACCESS_ADD))
        echo ' | <A HREF="'.pnModURL('PayPalCart','admin','editcategorymenu', array('authid' => $authid)).'" CLASS="pn-normal">'._PPC_ADDCATEGORY.'</A> ';
		
		
		if (pnSecAuthAction(0, 'PayPalCart:Option:Edit', '::', ACCESS_ADD))
        echo ' | <A HREF="'.pnModURL('PayPalCart','admin','editoptionmenu', array('authid' => $authid)).'" CLASS="pn-normal">'._PPC_ADDOPTION.'</A> ';
		
		if (pnSecAuthAction(0, 'PayPalCart:Config:Edit', '::', ACCESS_ADMIN)) 
        echo ' | <A HREF="'.pnModURL('PayPalCart','admin','modifyconfig', array('authid' => $authid)).'" CLASS="pn-normal">'._PPC_UPDATECONFIG.'</A>'
			
		?>
		
		&nbsp;]</SPAN><BR><BR>
		
		
		<?php
		
    return;

}

// Generic error function
function paypalcart_admin_deleteconfirm($pagetitle, $confirmtext, $confirmurl, $cancelurl, $authid) {

    OpenTable();

    ?>
    <DIV ALIGN="CENTER">
    
		<?php

    OpenTable2();

    ?>
		
		<span class="pn-title"><?php echo $pagetitle; ?></span>
		
		<?php

    CloseTable2();

    ?>	
		
		</DIV>
		<DIV ALIGN="LEFT"><span class="pn-normal"><?php echo $confirmtext; ?></span></DIV>	
		<BR><BR>

    <DIV ALIGN="CENTER">	
		<FORM ACTION="<?php echo $confirmurl; ?>" METHOD="POST" enctype="application/x-www-form-urlencoded">
    <input type="hidden" name="confirm" id="confirm" value="1">
		<input type="hidden" name="authid" id="authid" value="<?php echo $authid; ?>">	
    <input type="hidden" name="confirmation" id="confirmation" value="1">
		<input type="submit" value="<?php echo _PPC_CONFIRM; ?>" align="center" tabindex="1" CLASS="pn-normal">		
		&nbsp;&nbsp;&nbsp;<INPUT TYPE="BUTTON" CLASS="pn-normal" STYLE="text-align: center;" onClick="window.location='<?php echo $cancelurl; ?>'" VALUE="<?php echo _PPC_CANCEL; ?>">
		</FORM>
		</DIV>	
		<BR><BR><BR>

<?php

CloseTable();

return;

}


// Generic error function
function paypalcart_admin_error($error) {

    pnSessionSetVar('statusmsg', $error);
    pnRedirect(pnModURL('PayPalCart', 'admin', 'main'));
				
   exit;				
}

?>