<?php
// File: $Id: paypalcart.php,v 1.12 2004/04/27 20:31:19 markwest Exp $ $Name:  $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file: Companion block for the PayPalCart module
// Displays featured item, random item, newest item
// ----------------------------------------------------------------------

if (eregi('paypalcart.php', $_SERVER['PHP_SELF'])) {
	die ('You can\'t access this file directly...');
}

$blocks_modules['paypalcart'] = array (
    'func_display' => 'blocks_paypalcart_display',
    'func_add' => 'blocks_paypalcart_add',
    'func_update' => 'blocks_paypalcart_update',
    'func_edit' => 'blocks_paypalcart_edit',
    'text_type' => 'PayPalCart',
    'text_type_long' => 'PayPalCart Item Block',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
    'show_preview' => true
);

pnSecAddSchema('PayPalCartblock::', 'Block title::');

function blocks_paypalcart_display($row) {

    pnModDBInfoLoad('PayPalCart');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();


    if (!pnSecAuthAction(0, 'PayPalCartblock::', "$row[title]::", ACCESS_READ)) {
        return;
    }
		
    $currency_markers = array ('USD' => '$',
                               'EUR' => '&#8364;',
														   'GBP' => '&pound;',
														   'CAD' => '$',
														   'JPY' => '&yen;');	 
	 
    $currency_symbol = $currency_markers[pnModGetVar('PayPalCart', 'currency')];	 	
		
    $content = explode('|', $row['content']);
	
		$row['content'] = '';

		$content[7] = str_replace("\'","'",$content[7]);			
		$content[8] = str_replace("\'","'",$content[8]);				
		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];	
		
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];			
		
		$query_start = "SELECT $ppc_items_column[pid], $ppc_items_column[cid], $ppc_items_column[name], $ppc_items_column[desc], $ppc_items_column[amount], $ppc_items_column[image_th]
		                FROM $ppc_items_table, $ppc_categories_table WHERE $ppc_categories_column[active] = '1' AND 
										$ppc_items_column[cid] = $ppc_categories_column[cid] AND $ppc_items_column[active] = '1' ";

		if ($content[0] == 'feat') {
		
		 // Select a specific item from the item table
		 $sql = "$query_start AND $ppc_items_column[pid] = '".$content[2]."'";
		
		} else {
		
		    if ($content[2]) // Specific category selected?
				    $cat_query .= "AND $ppc_items_column[cid] = '".$content[2]."' ";
						
				if ($content[1])
				    $limit_query = "AND $ppc_items_column[order] <= '".$content[1]."' ";
				    
			 $sql = "$query_start $cat_query $limit_query ORDER BY RAND() LIMIT 1";	
		
		}
		
    $result = $dbconn->Execute($sql);
    list($pid, $cid, $prod_name, $desc, $amount, $image_th) = $result->fields;				
		
    // Check permissions on item
		if ($content[0] == 'feat') {
			
				if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ))
				    $item_match = 1;
				else
				    $item_match = 0;
		
		} else {
		
		    if ($content[2] && !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
				    $item_match = 0;
				} else {
		
		        while (!$item_match) {
				
						    if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
				            $item_match = 1;
								    continue;
						    }
						
						    $count++;	
		
                $result = $dbconn->Execute($sql);
                list($pid, $cid, $prod_name, $desc, $amount, $image_th) = $result->fields;
						
						    if ($count > 20) {
				            $item_match = 0;
								    continue;						
						    }						
				
				    }
				}		
		}		
		
		if ($item_match) { 
		
        if ($content[8])
		        $row['content'].= '<div align="left"><span class="pn-sub">'.nl2br(trim($content[8])).'</span></div>';

		    $row['content'].= '<div align="center"><span class="pn-normal"><a href="'.pnModURL('PayPalCart','user','detail', array('pid' => $pid)).'" class="pn-normal">';
				
		    $item_image_th = pnModGetVar('PayPalCart', 'imagepath').$image_th;			
			
		    if ($content[3] && $image_th && file_exists($item_image_th))
		        $row['content'].= '<a href="'.pnModURL('PayPalCart','user','detail', array('pid' => $pid)).'"><img src="'.$item_image_th.'" border="0" alt="'.$prod_name.'" vspace="5"></a><br>';
			
		    $row['content'].= '<a href="'.pnModURL('PayPalCart','user','detail', array('pid' => $pid)).'" class="pn-normal"><b>'.$prod_name.'</b></a>';
				
				if ($content[4]) {
				   if (strlen($desc) > $content[5])
					    $desc = substr($desc,0,$content[5]).'...';
					 
			     $row['content'].= '<BR><div align="left"><span class="pn-sub">'.$desc.'</span></div>';				 
				}	
				
				$row['content'].= '<br>';	
				
				if ($content[7])
		    $row['content'].= $content[7].' ';			 
				
		    $row['content'].= '<b>'.$currency_symbol.$amount.'</b>';	
				
				if ($content[6])
		    $row['content'].= '<BR><SPAN CLASS="pn-sub">[&nbsp;<A HREF="'.pnModURL('PayPalCart','user','main').'" CLASS="pn-normal">'._PPC_VISITSTORE.'</A>&nbsp;]</SPAN>';															

		    $row['content'].= '</span></div>';
				
		} else {

		    return false;

		}			
		
        return themesideblock($row);
}


function blocks_paypalcart_add($row) {

    $row['content'] = 'rand|||1|1|100|1||';
    return $row;
}

function blocks_paypalcart_update($vars) {

    if ($vars[rand_feat] == 'rand') {
      $vars[cat_item_id] = $vars[cat_id];
		  $vars[last_num] = intval($vars[last_num]);
			
		  if ($vars[last_num] <= 0 && $vars[last_num_check])
		      $vars[last_num] = '10';
			elseif (!$vars[last_num_check])
		      $vars[last_num] = '0';			
		} else {	
      $vars[cat_item_id] = $vars[item_id];
		  $vars[last_num] = '0';			
		}
		
    if ($vars[desc_chars] < 10)
		    $vars[desc_chars] = 10;		

    $vars['content'] = "$vars[rand_feat]|$vars[last_num]|$vars[cat_item_id]|$vars[show_thumb]|$vars[show_desc]|$vars[desc_chars]|$vars[show_link]|$vars[price_prefix]|$vars[item_text]";
    return $vars;
}

function blocks_paypalcart_edit($row) {

    if (!empty($row['content'])) {
        $content = explode('|', $row['content']);
        $rand_feat = $content[0];
        $last_num = $content[1];
        $cat_item_id = $content[2];
        $show_thumb = $content[3];
        $show_desc = $content[4];
        $desc_chars = $content[5];
        $show_link = $content[6];
        $price_prefix = $content[7];																				
        $item_text = $content[8];												
    } else {
        $rand_feat = 'rand';
        $last_num = '0';
        $cat_item_id = '0';
        $show_thumb = '1';
        $show_desc = '1';	
        $desc_chars = '100';	
        $show_link = '1';	
        $price_prefix = '';																	
        $item_text = '';		
    }
		
		if ($rand_feat == 'rand') {
		  $rand_check = 'CHECKED="CHECKED"';
			$cat_id = $cat_item_id;
		} else {  
			$feat_check = 'CHECKED="CHECKED"';
			$item_id = $cat_item_id;			
		}
			
		if ($last_num)
			$last_check = 'CHECKED="CHECKED"';				
			
		if ($show_thumb)
			$thumb_check = 'CHECKED="CHECKED"';
			
		if ($show_desc)
			$desc_check = 'CHECKED="CHECKED"';	
			
		if ($show_link)
			$link_check = 'CHECKED="CHECKED"';						
			
		$item_text = str_replace("\'","'",$item_text);
		
		$price_prefix = str_replace("\'","'",$price_prefix);						
						
		
    $output = '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_RANDOMITEMS.'</td><td class="pn-normal" nowrap="nowrap">'
        .'<input type="radio" name="rand_feat" value="rand" '.$rand_check.' class="pn-normal">'
        .'&nbsp;&nbsp;&nbsp;&nbsp;'._PPCBLOCK_FROMTHISCAT.':&nbsp;&nbsp<select name="cat_id" class="pn-normal">'
				.'<option value="0">'._PPCBLOCK_SHOWALLCATS.'</option>';
    $output .= blocks_paypalcart_categoryselectlist($cat_id);
    $output .= '</select>'
		.'<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="last_num_check" value="1" '.$last_check.' class="pn-normal"> '._PPCBLOCK_FIRST
		.' <input type="text" name="last_num" size="2" maxlength="4" value="'.$last_num.'" class="pn-normal"> '
    . _PPCBLOCK_ITEMSONLY.'</td></tr>';
				
    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_FEATUREDITEM.'</td><td class="pn-normal">'
        .'<input type="radio" name="rand_feat" value="feat" '.$feat_check.' class="pn-normal">'
        .'&nbsp;&nbsp;<select name="item_id" class="pn-normal">';
		$output .= blocks_paypalcart_itemselectlist($item_id);
		$output .= '</select></td></tr>';
				
    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_SHOWTHUMB.'</td><td class="pn-normal">'
        .'<input type="checkbox" name="show_thumb" value="1" '.$thumb_check.' class="pn-normal"></td></tr>';
				
    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_SHOWLINK.'</td><td class="pn-normal">'
        .'<input type="checkbox" name="show_link" value="1" '.$link_check.' class="pn-normal"></td></tr>';		
				
    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_SHOWDESC.'</td><td class="pn-normal">'
        .'<input type="checkbox" name="show_desc" value="1" '.$desc_check.' class="pn-normal">&nbsp&nbsp;'._PPCBLOCK_FIRST.' <input type="text" name="desc_chars" size="3" maxlength="4" value="'.$desc_chars.'" class="pn-normal"> '._PPCBLOCK_CHARS.'</td></tr>';							

    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_PRICE_PREFIX.'</td><td class="pn-normal">'
        .'<input type="text" name="price_prefix" size="15" maxlength="25" value="'.$price_prefix.'" class="pn-normal"></td></tr>';	

				
    $output .= '<tr><td valign="top" class="pn-normal">'._PPCBLOCK_INTROTEXT.'</td><td class="pn-normal">'
        .'<textarea name="item_text" cols="30" rows="2" maxlength="255" class="pn-normal">'.pnVarPrepForDisplay($item_text).'</textarea>'
        .'</td></tr>';
				
    return $output;
}

// Create a select list of available categories
function blocks_paypalcart_categoryselectlist($selected = '') {

    pnModDBInfoLoad('PayPalCart');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];

    $sql = "SELECT $ppc_categories_column[cid], $ppc_categories_column[name] FROM $ppc_categories_table WHERE $ppc_categories_column[active] = '1' ORDER BY $ppc_categories_column[order]";
		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        
				list($cid, $cat_name) = $result->fields;
				
        $output .= '<OPTION VALUE="'.$cid.'"';
	
        if ($cid == $selected)
            $output .= ' SELECTED="SELECTED"';			
			
		    $output .= '>'.$cat_name.'</OPTION>';			
				
    }							

    $result->Close();		

		return $output;
}

// Create a select list of available categories
function blocks_paypalcart_itemselectlist($selected = '') {

    
    pnModDBInfoLoad('PayPalCart');
		list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];

    $sql = "SELECT $ppc_items_column[pid], $ppc_items_column[name] FROM $ppc_items_table WHERE $ppc_items_column[active] = '1' ORDER BY $ppc_items_column[name], $ppc_items_column[cid]";
		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        
				list($pid, $prod_name) = $result->fields;
				
        $output .= '<OPTION VALUE="'.$pid.'"';
	
        if ($pid == $selected)
            $output .= ' SELECTED="SELECTED"';			
			
		    $output .= '>'.$prod_name.'</OPTION>';			
				
    }							

    $result->Close();		

		return $output;
}
?>