<?php
// $Id: pninit.php,v 1.1.1.1 2002/09/15 22:26:15 root Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file:  Initialisation functions for PayPalCart module
// ----------------------------------------------------------------------

// Initialize the PayPalCart module
function paypalcart_init() {

    // Get database setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];

    // Create the category table
		$sql = "CREATE TABLE $ppc_categories_table (
            $ppc_categories_column[cid] int(10) NOT NULL auto_increment,
            $ppc_categories_column[name] varchar(64) NOT NULL default '',
            $ppc_categories_column[desc] text NOT NULL default '',
            $ppc_categories_column[itemcolumns] int(2) NOT NULL default 3,				
            $ppc_categories_column[active] int(1) NOT NULL default 1,
            $ppc_categories_column[image] varchar(64) NOT NULL default '',	
            $ppc_categories_column[order] int(10) NOT NULL default 0,																		
            PRIMARY KEY(pn_cid))";
    $dbconn->Execute($sql);

    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATETABLEFAILED);
        return false;
    }
		
    // Get the item table & column names		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];

    // Create the items table
		$sql = "CREATE TABLE $ppc_items_table (
            $ppc_items_column[pid] int(10) NOT NULL auto_increment,
            $ppc_items_column[cid] int(10) NOT NULL default 0,						
            $ppc_items_column[name] varchar(64) NOT NULL default '',
            $ppc_items_column[sku] varchar(32) NOT NULL default '',	
            $ppc_items_column[desc] text NOT NULL default '',											
            $ppc_items_column[amount] double(6,2)    NOT NULL default '0.00',
            $ppc_items_column[option1] int(10) NOT NULL default 0,	
            $ppc_items_column[option2] int(10) NOT NULL default 0,
            $ppc_items_column[shipping] double(6,2)    NOT NULL default '0.00',
            $ppc_items_column[shipping2] double(6,2)    NOT NULL default '0.00',
            $ppc_items_column[handling] double(6,2)    NOT NULL default '0.00',	
            $ppc_items_column[active] int(1) NOT NULL default 1,	
            $ppc_items_column[image_th] varchar(64) NOT NULL default '',	
            $ppc_items_column[image] varchar(64) NOT NULL default '',	
            $ppc_items_column[order] int(10) NOT NULL default 0,																																																						
            PRIMARY KEY(pn_pid))";
    $dbconn->Execute($sql);

    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATETABLEFAILED);
        return false;
    }
		
    // Get the option table & column names		
    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];

    // Create the options table
		$sql = "CREATE TABLE $ppc_options_table (
            $ppc_options_column[oid] int(10) NOT NULL auto_increment,
            $ppc_options_column[name] varchar(32) NOT NULL default '',		
            $ppc_options_column[label] varchar(32) NOT NULL default '',	
            $ppc_options_column[desc] text NOT NULL default '',																					
            $ppc_options_column[style] int(0) NOT NULL default '0',		
            PRIMARY KEY(pn_oid))";
    $dbconn->Execute($sql);

    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATETABLEFAILED);
        return false;
    }
		
    // Get the option value table & column names		
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];

    // Create the option values table
		$sql = "CREATE TABLE $ppc_optionval_table (
            $ppc_optionval_column[vid] int(10) NOT NULL auto_increment,
            $ppc_optionval_column[oid] int(10) NOT NULL default 0,	
            $ppc_optionval_column[value] varchar(32) NOT NULL default '',								
            $ppc_optionval_column[order] int(10) NOT NULL default 0,	
            PRIMARY KEY(pn_vid))";
    $dbconn->Execute($sql);

    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATETABLEFAILED);
        return false;
    }						

    // Set up initial values for the module variables.
		pnModSetVar('PayPalCart', 'paypal_email', 'your_email@paypal.com');
    pnModSetVar('PayPalCart', 'store_email', 'store_email@yourdomain.com');
    pnModSetVar('PayPalCart', 'currency', 'USD');
    pnModSetVar('PayPalCart', 'handling_cart', '0.00');
    pnModSetVar('PayPalCart', 'note', 0);
    pnModSetVar('PayPalCart', 'notemsg', 'Insert note message to appear above note field on order.');
    pnModSetVar('PayPalCart', 'shippingaddr', 0);
    pnModSetVar('PayPalCart', 'page_style', '');
    pnModSetVar('PayPalCart', 'image_url', '');
    pnModSetVar('PayPalCart', 'bgcolor', '0');
    pnModSetVar('PayPalCart', 'storename', 'PayPal Store Name');		
    pnModSetVar('PayPalCart', 'storeintro', 'Insert introduction text to be included on your store home page.');		
    pnModSetVar('PayPalCart', 'storeinfo', 'Insert store policy page text here, including shipping returns, etc...');			
    pnModSetVar('PayPalCart', 'storelogo', '');			
    pnModSetVar('PayPalCart', 'thankstitle', 'Thanks for your Order!');		
    pnModSetVar('PayPalCart', 'thankstext', 'Your order has been received and will ship in 2 weeks. We thank you for your patronage.');		
    pnModSetVar('PayPalCart', 'itemsperpage', 5);	
    pnModSetVar('PayPalCart', 'buttondetailonly', 0);			
    pnModSetVar('PayPalCart', 'categorycolumns', 2);			
    pnModSetVar('PayPalCart', 'imagepath', 'images/storeimages/');	
    pnModSetVar('PayPalCart', 'buttonimage', 'button_addcart_1.gif');	
    pnModSetVar('PayPalCart', 'viewcartimage', 'button_viewcart_1.gif');	
    pnModSetVar('PayPalCart', 'nojscript', '0');					
    pnModSetVar('PayPalCart', 'cartwindowwidth', '720');		
    pnModSetVar('PayPalCart', 'cartwindowheight', '480');								
																														

    // Initialisation successful
    return true;
}


function paypalcart_delete() {

    // Get database setup
		list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Drop the category table
		$sql = "DROP TABLE $pntable[paypalcart_categories]";
    $dbconn->Execute($sql);

    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }

    // Drop the item table
		$sql = "DROP TABLE $pntable[paypalcart_items]";
    $dbconn->Execute($sql);

    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }
		
    // Drop the option table
		$sql = "DROP TABLE $pntable[paypalcart_options]";
    $dbconn->Execute($sql);

    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }
		
    // Drop the option values table
		$sql = "DROP TABLE $pntable[paypalcart_option_values]";
    $dbconn->Execute($sql);

    // Check for an error with the database code
    if ($dbconn->ErrorNo() != 0) {
        // Report failed deletion attempt
        return false;
    }	

    // Delete any module variables
		pnModDelVar('PayPalCart', 'paypal_email');
    pnModDelVar('PayPalCart', 'store_email');
    pnModDelVar('PayPalCart', 'currency');
    pnModDelVar('PayPalCart', 'handling_cart');
    pnModDelVar('PayPalCart', 'note');
    pnModDelVar('PayPalCart', 'notemsg');
    pnModDelVar('PayPalCart', 'shippingaddr');
    pnModDelVar('PayPalCart', 'page_style');
    pnModDelVar('PayPalCart', 'image_url');
    pnModDelVar('PayPalCart', 'bgcolor');
    pnModDelVar('PayPalCart', 'storename');		
    pnModDelVar('PayPalCart', 'storeintro');	
    pnModDelVar('PayPalCart', 'storeinfo');			
    pnModDelVar('PayPalCart', 'storelogo');				
    pnModDelVar('PayPalCart', 'thankstitle');		
    pnModDelVar('PayPalCart', 'thankstext');		
    pnModDelVar('PayPalCart', 'itemsperpage');	
    pnModDelVar('PayPalCart', 'buttondetailonly');			
    pnModDelVar('PayPalCart', 'categorycolumns');				
    pnModDelVar('PayPalCart', 'imagepath');		
    pnModDelVar('PayPalCart', 'buttonimage');		
    pnModDelVar('PayPalCart', 'viewcartimage');	
    pnModDelVar('PayPalCart', 'nojscript');					
    pnModDelVar('PayPalCart', 'cartwindowwidth');		
    pnModDelVar('PayPalCart', 'cartwindowheight');														

    // Deletion successful
    return true;
}

?>